# coding: utf-8

"""
    Songtradr API

    This is the Songtradr API. Use it to retrieve deep music metadata and trigger processes like auto-tagging.  You can also use the API to manage your account and musicube cloud data.  **Authentication**  1. Reach out to support@songtradr.com to receive a free account or use your login data if you are already signed up.  2. To authenticate, you need to login via the POST /api/v1/user/login endpoint.  3. The endpoint responds with a jwtToken which you can use in all following API requests as a bearer token.  **Rate Limiting**  The current limit is 120 Requests per minute. Reach out to us via support@songtradr.com if you need to request more.  **Getting Started with auto-tagging**  1. If you want to get your own files auto-tagged, use the POST /api/v1/user/file/{name}/initUpload endpoint. It responds with a presigned S3 link where you can upload your file. 2. You can check the processing status of your file via the GET /api/v1/user/file/{name}/filesStatus endpoint. 3. As soon as processing is done, you can request the generated data via the GET /api/v1/user/files endpoint.  **Getting Started with search**  You can either search the released music via the /public/recording endpoints or your own private uploaded music via the /user/file/ endpoints.  1. If you want to search the world's released music, a good starting point is the GET /api/v1/public/recording/search endpoint. Please find the extensive list of parameters that serve as semantic search filters. 2. If you want to search your own previously uploaded music, a good starting point is the GET GET /api/v1/user/files endpoint. It has the same extensive list of parameters that serve as semantic search filters.  # noqa: E501

    The version of the OpenAPI document: 1.12.21
    Contact: info@songtradr.com
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from songtradr_api_client_python import schemas  # noqa: F401


class SaveFileRecordingDTO(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Data crafted by AI or users.
    """


    class MetaOapg:
        required = {
            "createdByVersion",
            "isrc",
        }
        
        class properties:
            isrc = schemas.StrSchema
            createdByVersion = schemas.StrSchema
            name = schemas.StrSchema
            folder = schemas.StrSchema
            primaryMoodClusterAffinity = schemas.Float32Schema
            
            
            class primaryMoodCluster(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "aggressive": "AGGRESSIVE",
                        "amusing": "AMUSING",
                        "anxious": "ANXIOUS",
                        "calm": "CALM",
                        "devotional": "DEVOTIONAL",
                        "dreamy": "DREAMY",
                        "energetic": "ENERGETIC",
                        "enigmatic": "ENIGMATIC",
                        "epic": "EPIC",
                        "erotic": "EROTIC",
                        "positive": "POSITIVE",
                        "sad": "SAD",
                        "scary": "SCARY",
                        "wild": "WILD",
                    }
                
                @schemas.classproperty
                def AGGRESSIVE(cls):
                    return cls("aggressive")
                
                @schemas.classproperty
                def AMUSING(cls):
                    return cls("amusing")
                
                @schemas.classproperty
                def ANXIOUS(cls):
                    return cls("anxious")
                
                @schemas.classproperty
                def CALM(cls):
                    return cls("calm")
                
                @schemas.classproperty
                def DEVOTIONAL(cls):
                    return cls("devotional")
                
                @schemas.classproperty
                def DREAMY(cls):
                    return cls("dreamy")
                
                @schemas.classproperty
                def ENERGETIC(cls):
                    return cls("energetic")
                
                @schemas.classproperty
                def ENIGMATIC(cls):
                    return cls("enigmatic")
                
                @schemas.classproperty
                def EPIC(cls):
                    return cls("epic")
                
                @schemas.classproperty
                def EROTIC(cls):
                    return cls("erotic")
                
                @schemas.classproperty
                def POSITIVE(cls):
                    return cls("positive")
                
                @schemas.classproperty
                def SAD(cls):
                    return cls("sad")
                
                @schemas.classproperty
                def SCARY(cls):
                    return cls("scary")
                
                @schemas.classproperty
                def WILD(cls):
                    return cls("wild")
            secondaryMoodClusterAffinity = schemas.Float32Schema
            
            
            class secondaryMoodCluster(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "aggressive": "AGGRESSIVE",
                        "amusing": "AMUSING",
                        "anxious": "ANXIOUS",
                        "calm": "CALM",
                        "devotional": "DEVOTIONAL",
                        "dreamy": "DREAMY",
                        "energetic": "ENERGETIC",
                        "enigmatic": "ENIGMATIC",
                        "epic": "EPIC",
                        "erotic": "EROTIC",
                        "positive": "POSITIVE",
                        "sad": "SAD",
                        "scary": "SCARY",
                        "wild": "WILD",
                    }
                
                @schemas.classproperty
                def AGGRESSIVE(cls):
                    return cls("aggressive")
                
                @schemas.classproperty
                def AMUSING(cls):
                    return cls("amusing")
                
                @schemas.classproperty
                def ANXIOUS(cls):
                    return cls("anxious")
                
                @schemas.classproperty
                def CALM(cls):
                    return cls("calm")
                
                @schemas.classproperty
                def DEVOTIONAL(cls):
                    return cls("devotional")
                
                @schemas.classproperty
                def DREAMY(cls):
                    return cls("dreamy")
                
                @schemas.classproperty
                def ENERGETIC(cls):
                    return cls("energetic")
                
                @schemas.classproperty
                def ENIGMATIC(cls):
                    return cls("enigmatic")
                
                @schemas.classproperty
                def EPIC(cls):
                    return cls("epic")
                
                @schemas.classproperty
                def EROTIC(cls):
                    return cls("erotic")
                
                @schemas.classproperty
                def POSITIVE(cls):
                    return cls("positive")
                
                @schemas.classproperty
                def SAD(cls):
                    return cls("sad")
                
                @schemas.classproperty
                def SCARY(cls):
                    return cls("scary")
                
                @schemas.classproperty
                def WILD(cls):
                    return cls("wild")
            tertiaryMoodClusterAffinity = schemas.Float32Schema
            
            
            class tertiaryMoodCluster(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "aggressive": "AGGRESSIVE",
                        "amusing": "AMUSING",
                        "anxious": "ANXIOUS",
                        "calm": "CALM",
                        "devotional": "DEVOTIONAL",
                        "dreamy": "DREAMY",
                        "energetic": "ENERGETIC",
                        "enigmatic": "ENIGMATIC",
                        "epic": "EPIC",
                        "erotic": "EROTIC",
                        "positive": "POSITIVE",
                        "sad": "SAD",
                        "scary": "SCARY",
                        "wild": "WILD",
                    }
                
                @schemas.classproperty
                def AGGRESSIVE(cls):
                    return cls("aggressive")
                
                @schemas.classproperty
                def AMUSING(cls):
                    return cls("amusing")
                
                @schemas.classproperty
                def ANXIOUS(cls):
                    return cls("anxious")
                
                @schemas.classproperty
                def CALM(cls):
                    return cls("calm")
                
                @schemas.classproperty
                def DEVOTIONAL(cls):
                    return cls("devotional")
                
                @schemas.classproperty
                def DREAMY(cls):
                    return cls("dreamy")
                
                @schemas.classproperty
                def ENERGETIC(cls):
                    return cls("energetic")
                
                @schemas.classproperty
                def ENIGMATIC(cls):
                    return cls("enigmatic")
                
                @schemas.classproperty
                def EPIC(cls):
                    return cls("epic")
                
                @schemas.classproperty
                def EROTIC(cls):
                    return cls("erotic")
                
                @schemas.classproperty
                def POSITIVE(cls):
                    return cls("positive")
                
                @schemas.classproperty
                def SAD(cls):
                    return cls("sad")
                
                @schemas.classproperty
                def SCARY(cls):
                    return cls("scary")
                
                @schemas.classproperty
                def WILD(cls):
                    return cls("wild")
            valenceAffinity = schemas.Float32Schema
            arousalAffinity = schemas.Float32Schema
            pleasantnessAffinity = schemas.Float32Schema
            engagementAffinity = schemas.Float32Schema
            
            
            class valence(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "very sad": "VERY_SAD",
                        "sad": "SAD",
                        "moderate valence": "MODERATE_VALENCE",
                        "positive": "POSITIVE",
                        "very positive": "VERY_POSITIVE",
                        "varying valence": "VARYING_VALENCE",
                    }
                
                @schemas.classproperty
                def VERY_SAD(cls):
                    return cls("very sad")
                
                @schemas.classproperty
                def SAD(cls):
                    return cls("sad")
                
                @schemas.classproperty
                def MODERATE_VALENCE(cls):
                    return cls("moderate valence")
                
                @schemas.classproperty
                def POSITIVE(cls):
                    return cls("positive")
                
                @schemas.classproperty
                def VERY_POSITIVE(cls):
                    return cls("very positive")
                
                @schemas.classproperty
                def VARYING_VALENCE(cls):
                    return cls("varying valence")
            
            
            class arousal(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "very calm": "VERY_CALM",
                        "calm": "CALM",
                        "moderate arousal": "MODERATE_AROUSAL",
                        "energetic": "ENERGETIC",
                        "very energetic": "VERY_ENERGETIC",
                        "varying arousal": "VARYING_AROUSAL",
                    }
                
                @schemas.classproperty
                def VERY_CALM(cls):
                    return cls("very calm")
                
                @schemas.classproperty
                def CALM(cls):
                    return cls("calm")
                
                @schemas.classproperty
                def MODERATE_AROUSAL(cls):
                    return cls("moderate arousal")
                
                @schemas.classproperty
                def ENERGETIC(cls):
                    return cls("energetic")
                
                @schemas.classproperty
                def VERY_ENERGETIC(cls):
                    return cls("very energetic")
                
                @schemas.classproperty
                def VARYING_AROUSAL(cls):
                    return cls("varying arousal")
            
            
            class pleasantness(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "very unpleasant": "VERY_UNPLEASANT",
                        "unpleasant": "UNPLEASANT",
                        "neutral pleasantness": "NEUTRAL_PLEASANTNESS",
                        "pleasant": "PLEASANT",
                        "very pleasant": "VERY_PLEASANT",
                        "varying pleasantness": "VARYING_PLEASANTNESS",
                    }
                
                @schemas.classproperty
                def VERY_UNPLEASANT(cls):
                    return cls("very unpleasant")
                
                @schemas.classproperty
                def UNPLEASANT(cls):
                    return cls("unpleasant")
                
                @schemas.classproperty
                def NEUTRAL_PLEASANTNESS(cls):
                    return cls("neutral pleasantness")
                
                @schemas.classproperty
                def PLEASANT(cls):
                    return cls("pleasant")
                
                @schemas.classproperty
                def VERY_PLEASANT(cls):
                    return cls("very pleasant")
                
                @schemas.classproperty
                def VARYING_PLEASANTNESS(cls):
                    return cls("varying pleasantness")
            
            
            class engagement(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "very unengaging": "VERY_UNENGAGING",
                        "unengaging": "UNENGAGING",
                        "neutral engagement": "NEUTRAL_ENGAGEMENT",
                        "engaging": "ENGAGING",
                        "very engaging": "VERY_ENGAGING",
                        "varying engagement": "VARYING_ENGAGEMENT",
                    }
                
                @schemas.classproperty
                def VERY_UNENGAGING(cls):
                    return cls("very unengaging")
                
                @schemas.classproperty
                def UNENGAGING(cls):
                    return cls("unengaging")
                
                @schemas.classproperty
                def NEUTRAL_ENGAGEMENT(cls):
                    return cls("neutral engagement")
                
                @schemas.classproperty
                def ENGAGING(cls):
                    return cls("engaging")
                
                @schemas.classproperty
                def VERY_ENGAGING(cls):
                    return cls("very engaging")
                
                @schemas.classproperty
                def VARYING_ENGAGEMENT(cls):
                    return cls("varying engagement")
            
            
            class vocals(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "instrumental": "INSTRUMENTAL",
                        "female vocals": "FEMALE_VOCALS",
                        "male vocals": "MALE_VOCALS",
                        "mixed vocals": "MIXED_VOCALS",
                        "diverse gender vocals": "DIVERSE_GENDER_VOCALS",
                    }
                
                @schemas.classproperty
                def INSTRUMENTAL(cls):
                    return cls("instrumental")
                
                @schemas.classproperty
                def FEMALE_VOCALS(cls):
                    return cls("female vocals")
                
                @schemas.classproperty
                def MALE_VOCALS(cls):
                    return cls("male vocals")
                
                @schemas.classproperty
                def MIXED_VOCALS(cls):
                    return cls("mixed vocals")
                
                @schemas.classproperty
                def DIVERSE_GENDER_VOCALS(cls):
                    return cls("diverse gender vocals")
            vocalsAffinity = schemas.Float32Schema
            
            
            class dominantInstrument(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "electric guitar": "ELECTRIC_GUITAR",
                        "piano": "PIANO",
                        "electronics": "ELECTRONICS",
                        "guitar": "GUITAR",
                        "strings": "STRINGS",
                        "synthesizer": "SYNTHESIZER",
                        "wind": "WIND",
                        "saxophone": "SAXOPHONE",
                        "flute": "FLUTE",
                        "trumpet": "TRUMPET",
                        "drum kit": "DRUM_KIT",
                        "keys": "KEYS",
                        "accordion": "ACCORDION",
                        "violin": "VIOLIN",
                        "harpsichord": "HARPSICHORD",
                        "choir": "CHOIR",
                        "cello": "CELLO",
                        "electric bass": "ELECTRIC_BASS",
                        "organ": "ORGAN",
                        "brass": "BRASS",
                        "percussion": "PERCUSSION",
                        "vocals": "VOCALS",
                        "double bass": "DOUBLE_BASS",
                        "harp": "HARP",
                    }
                
                @schemas.classproperty
                def ELECTRIC_GUITAR(cls):
                    return cls("electric guitar")
                
                @schemas.classproperty
                def PIANO(cls):
                    return cls("piano")
                
                @schemas.classproperty
                def ELECTRONICS(cls):
                    return cls("electronics")
                
                @schemas.classproperty
                def GUITAR(cls):
                    return cls("guitar")
                
                @schemas.classproperty
                def STRINGS(cls):
                    return cls("strings")
                
                @schemas.classproperty
                def SYNTHESIZER(cls):
                    return cls("synthesizer")
                
                @schemas.classproperty
                def WIND(cls):
                    return cls("wind")
                
                @schemas.classproperty
                def SAXOPHONE(cls):
                    return cls("saxophone")
                
                @schemas.classproperty
                def FLUTE(cls):
                    return cls("flute")
                
                @schemas.classproperty
                def TRUMPET(cls):
                    return cls("trumpet")
                
                @schemas.classproperty
                def DRUM_KIT(cls):
                    return cls("drum kit")
                
                @schemas.classproperty
                def KEYS(cls):
                    return cls("keys")
                
                @schemas.classproperty
                def ACCORDION(cls):
                    return cls("accordion")
                
                @schemas.classproperty
                def VIOLIN(cls):
                    return cls("violin")
                
                @schemas.classproperty
                def HARPSICHORD(cls):
                    return cls("harpsichord")
                
                @schemas.classproperty
                def CHOIR(cls):
                    return cls("choir")
                
                @schemas.classproperty
                def CELLO(cls):
                    return cls("cello")
                
                @schemas.classproperty
                def ELECTRIC_BASS(cls):
                    return cls("electric bass")
                
                @schemas.classproperty
                def ORGAN(cls):
                    return cls("organ")
                
                @schemas.classproperty
                def BRASS(cls):
                    return cls("brass")
                
                @schemas.classproperty
                def PERCUSSION(cls):
                    return cls("percussion")
                
                @schemas.classproperty
                def VOCALS(cls):
                    return cls("vocals")
                
                @schemas.classproperty
                def DOUBLE_BASS(cls):
                    return cls("double bass")
                
                @schemas.classproperty
                def HARP(cls):
                    return cls("harp")
            dominantInstrumentAffinity = schemas.Float32Schema
            secondaryInstrumentAffinity = schemas.Float32Schema
            
            
            class secondaryInstrument(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "electric guitar": "ELECTRIC_GUITAR",
                        "piano": "PIANO",
                        "electronics": "ELECTRONICS",
                        "guitar": "GUITAR",
                        "strings": "STRINGS",
                        "synthesizer": "SYNTHESIZER",
                        "wind": "WIND",
                        "saxophone": "SAXOPHONE",
                        "flute": "FLUTE",
                        "trumpet": "TRUMPET",
                        "drum kit": "DRUM_KIT",
                        "keys": "KEYS",
                        "accordion": "ACCORDION",
                        "violin": "VIOLIN",
                        "harpsichord": "HARPSICHORD",
                        "choir": "CHOIR",
                        "cello": "CELLO",
                        "electric bass": "ELECTRIC_BASS",
                        "organ": "ORGAN",
                        "brass": "BRASS",
                        "percussion": "PERCUSSION",
                        "vocals": "VOCALS",
                        "double bass": "DOUBLE_BASS",
                        "harp": "HARP",
                    }
                
                @schemas.classproperty
                def ELECTRIC_GUITAR(cls):
                    return cls("electric guitar")
                
                @schemas.classproperty
                def PIANO(cls):
                    return cls("piano")
                
                @schemas.classproperty
                def ELECTRONICS(cls):
                    return cls("electronics")
                
                @schemas.classproperty
                def GUITAR(cls):
                    return cls("guitar")
                
                @schemas.classproperty
                def STRINGS(cls):
                    return cls("strings")
                
                @schemas.classproperty
                def SYNTHESIZER(cls):
                    return cls("synthesizer")
                
                @schemas.classproperty
                def WIND(cls):
                    return cls("wind")
                
                @schemas.classproperty
                def SAXOPHONE(cls):
                    return cls("saxophone")
                
                @schemas.classproperty
                def FLUTE(cls):
                    return cls("flute")
                
                @schemas.classproperty
                def TRUMPET(cls):
                    return cls("trumpet")
                
                @schemas.classproperty
                def DRUM_KIT(cls):
                    return cls("drum kit")
                
                @schemas.classproperty
                def KEYS(cls):
                    return cls("keys")
                
                @schemas.classproperty
                def ACCORDION(cls):
                    return cls("accordion")
                
                @schemas.classproperty
                def VIOLIN(cls):
                    return cls("violin")
                
                @schemas.classproperty
                def HARPSICHORD(cls):
                    return cls("harpsichord")
                
                @schemas.classproperty
                def CHOIR(cls):
                    return cls("choir")
                
                @schemas.classproperty
                def CELLO(cls):
                    return cls("cello")
                
                @schemas.classproperty
                def ELECTRIC_BASS(cls):
                    return cls("electric bass")
                
                @schemas.classproperty
                def ORGAN(cls):
                    return cls("organ")
                
                @schemas.classproperty
                def BRASS(cls):
                    return cls("brass")
                
                @schemas.classproperty
                def PERCUSSION(cls):
                    return cls("percussion")
                
                @schemas.classproperty
                def VOCALS(cls):
                    return cls("vocals")
                
                @schemas.classproperty
                def DOUBLE_BASS(cls):
                    return cls("double bass")
                
                @schemas.classproperty
                def HARP(cls):
                    return cls("harp")
            tertiaryInstrumentAffinity = schemas.Float32Schema
            
            
            class tertiaryInstrument(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "electric guitar": "ELECTRIC_GUITAR",
                        "piano": "PIANO",
                        "electronics": "ELECTRONICS",
                        "guitar": "GUITAR",
                        "strings": "STRINGS",
                        "synthesizer": "SYNTHESIZER",
                        "wind": "WIND",
                        "saxophone": "SAXOPHONE",
                        "flute": "FLUTE",
                        "trumpet": "TRUMPET",
                        "drum kit": "DRUM_KIT",
                        "keys": "KEYS",
                        "accordion": "ACCORDION",
                        "violin": "VIOLIN",
                        "harpsichord": "HARPSICHORD",
                        "choir": "CHOIR",
                        "cello": "CELLO",
                        "electric bass": "ELECTRIC_BASS",
                        "organ": "ORGAN",
                        "brass": "BRASS",
                        "percussion": "PERCUSSION",
                        "vocals": "VOCALS",
                        "double bass": "DOUBLE_BASS",
                        "harp": "HARP",
                    }
                
                @schemas.classproperty
                def ELECTRIC_GUITAR(cls):
                    return cls("electric guitar")
                
                @schemas.classproperty
                def PIANO(cls):
                    return cls("piano")
                
                @schemas.classproperty
                def ELECTRONICS(cls):
                    return cls("electronics")
                
                @schemas.classproperty
                def GUITAR(cls):
                    return cls("guitar")
                
                @schemas.classproperty
                def STRINGS(cls):
                    return cls("strings")
                
                @schemas.classproperty
                def SYNTHESIZER(cls):
                    return cls("synthesizer")
                
                @schemas.classproperty
                def WIND(cls):
                    return cls("wind")
                
                @schemas.classproperty
                def SAXOPHONE(cls):
                    return cls("saxophone")
                
                @schemas.classproperty
                def FLUTE(cls):
                    return cls("flute")
                
                @schemas.classproperty
                def TRUMPET(cls):
                    return cls("trumpet")
                
                @schemas.classproperty
                def DRUM_KIT(cls):
                    return cls("drum kit")
                
                @schemas.classproperty
                def KEYS(cls):
                    return cls("keys")
                
                @schemas.classproperty
                def ACCORDION(cls):
                    return cls("accordion")
                
                @schemas.classproperty
                def VIOLIN(cls):
                    return cls("violin")
                
                @schemas.classproperty
                def HARPSICHORD(cls):
                    return cls("harpsichord")
                
                @schemas.classproperty
                def CHOIR(cls):
                    return cls("choir")
                
                @schemas.classproperty
                def CELLO(cls):
                    return cls("cello")
                
                @schemas.classproperty
                def ELECTRIC_BASS(cls):
                    return cls("electric bass")
                
                @schemas.classproperty
                def ORGAN(cls):
                    return cls("organ")
                
                @schemas.classproperty
                def BRASS(cls):
                    return cls("brass")
                
                @schemas.classproperty
                def PERCUSSION(cls):
                    return cls("percussion")
                
                @schemas.classproperty
                def VOCALS(cls):
                    return cls("vocals")
                
                @schemas.classproperty
                def DOUBLE_BASS(cls):
                    return cls("double bass")
                
                @schemas.classproperty
                def HARP(cls):
                    return cls("harp")
            
            
            class energy(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "very quiet": "VERY_QUIET",
                        "quiet": "QUIET",
                        "moderate": "MODERATE",
                        "loud": "LOUD",
                        "very loud": "VERY_LOUD",
                        "dynamic": "DYNAMIC",
                    }
                
                @schemas.classproperty
                def VERY_QUIET(cls):
                    return cls("very quiet")
                
                @schemas.classproperty
                def QUIET(cls):
                    return cls("quiet")
                
                @schemas.classproperty
                def MODERATE(cls):
                    return cls("moderate")
                
                @schemas.classproperty
                def LOUD(cls):
                    return cls("loud")
                
                @schemas.classproperty
                def VERY_LOUD(cls):
                    return cls("very loud")
                
                @schemas.classproperty
                def DYNAMIC(cls):
                    return cls("dynamic")
            energyAffinity = schemas.Float32Schema
            
            
            class soundGeneration(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "acoustic": "ACOUSTIC",
                        "electric": "ELECTRIC",
                        "electronic": "ELECTRONIC",
                        "mixed sound generation": "MIXED_SOUND_GENERATION",
                    }
                
                @schemas.classproperty
                def ACOUSTIC(cls):
                    return cls("acoustic")
                
                @schemas.classproperty
                def ELECTRIC(cls):
                    return cls("electric")
                
                @schemas.classproperty
                def ELECTRONIC(cls):
                    return cls("electronic")
                
                @schemas.classproperty
                def MIXED_SOUND_GENERATION(cls):
                    return cls("mixed sound generation")
            soundGenerationAffinity = schemas.Float32Schema
            
            
            class tempo(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "very slow": "VERY_SLOW",
                        "slow": "SLOW",
                        "mid-tempo": "MIDTEMPO",
                        "fast": "FAST",
                        "very fast": "VERY_FAST",
                        "varying tempo": "VARYING_TEMPO",
                    }
                
                @schemas.classproperty
                def VERY_SLOW(cls):
                    return cls("very slow")
                
                @schemas.classproperty
                def SLOW(cls):
                    return cls("slow")
                
                @schemas.classproperty
                def MIDTEMPO(cls):
                    return cls("mid-tempo")
                
                @schemas.classproperty
                def FAST(cls):
                    return cls("fast")
                
                @schemas.classproperty
                def VERY_FAST(cls):
                    return cls("very fast")
                
                @schemas.classproperty
                def VARYING_TEMPO(cls):
                    return cls("varying tempo")
            tempoAffinity = schemas.Float32Schema
            
            
            class scale(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "major key": "MAJOR_KEY",
                        "minor key": "MINOR_KEY",
                        "neutral key": "NEUTRAL_KEY",
                    }
                
                @schemas.classproperty
                def MAJOR_KEY(cls):
                    return cls("major key")
                
                @schemas.classproperty
                def MINOR_KEY(cls):
                    return cls("minor key")
                
                @schemas.classproperty
                def NEUTRAL_KEY(cls):
                    return cls("neutral key")
            scaleAffinity = schemas.Float32Schema
            
            
            class rhythm(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "common time": "COMMON_TIME",
                        "triple meter": "TRIPLE_METER",
                        "complex time signature": "COMPLEX_TIME_SIGNATURE",
                        "binary rhythm": "BINARY_RHYTHM",
                        "ternary rhythm": "TERNARY_RHYTHM",
                    }
                
                @schemas.classproperty
                def COMMON_TIME(cls):
                    return cls("common time")
                
                @schemas.classproperty
                def TRIPLE_METER(cls):
                    return cls("triple meter")
                
                @schemas.classproperty
                def COMPLEX_TIME_SIGNATURE(cls):
                    return cls("complex time signature")
                
                @schemas.classproperty
                def BINARY_RHYTHM(cls):
                    return cls("binary rhythm")
                
                @schemas.classproperty
                def TERNARY_RHYTHM(cls):
                    return cls("ternary rhythm")
            rhythmAffinity = schemas.Float32Schema
            
            
            class primarySoundCharacter(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "brassy": "BRASSY",
                        "bright": "BRIGHT",
                        "clear": "CLEAR",
                        "deep": "DEEP",
                        "distorted": "DISTORTED",
                        "flat": "FLAT",
                        "full": "FULL",
                        "groovy": "GROOVY",
                        "melodious": "MELODIOUS",
                        "natural": "NATURAL",
                        "resonant": "RESONANT",
                        "shrill": "SHRILL",
                        "steady": "STEADY",
                        "thin": "THIN",
                        "warm": "WARM",
                    }
                
                @schemas.classproperty
                def BRASSY(cls):
                    return cls("brassy")
                
                @schemas.classproperty
                def BRIGHT(cls):
                    return cls("bright")
                
                @schemas.classproperty
                def CLEAR(cls):
                    return cls("clear")
                
                @schemas.classproperty
                def DEEP(cls):
                    return cls("deep")
                
                @schemas.classproperty
                def DISTORTED(cls):
                    return cls("distorted")
                
                @schemas.classproperty
                def FLAT(cls):
                    return cls("flat")
                
                @schemas.classproperty
                def FULL(cls):
                    return cls("full")
                
                @schemas.classproperty
                def GROOVY(cls):
                    return cls("groovy")
                
                @schemas.classproperty
                def MELODIOUS(cls):
                    return cls("melodious")
                
                @schemas.classproperty
                def NATURAL(cls):
                    return cls("natural")
                
                @schemas.classproperty
                def RESONANT(cls):
                    return cls("resonant")
                
                @schemas.classproperty
                def SHRILL(cls):
                    return cls("shrill")
                
                @schemas.classproperty
                def STEADY(cls):
                    return cls("steady")
                
                @schemas.classproperty
                def THIN(cls):
                    return cls("thin")
                
                @schemas.classproperty
                def WARM(cls):
                    return cls("warm")
            primarySoundCharacterAffinity = schemas.Float32Schema
            timbreAffinity = schemas.Float32Schema
            roughnessAffinity = schemas.Float32Schema
            tonalityAffinity = schemas.Float32Schema
            harmonyAffinity = schemas.Float32Schema
            textureAffinity = schemas.Float32Schema
            groovynessAffinity = schemas.Float32Schema
            spaceAffinity = schemas.Float32Schema
            
            
            class timbre(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "very warm": "VERY_WARM",
                        "warm": "WARM",
                        "moderate timbre": "MODERATE_TIMBRE",
                        "bright": "BRIGHT",
                        "very bright": "VERY_BRIGHT",
                    }
                
                @schemas.classproperty
                def VERY_WARM(cls):
                    return cls("very warm")
                
                @schemas.classproperty
                def WARM(cls):
                    return cls("warm")
                
                @schemas.classproperty
                def MODERATE_TIMBRE(cls):
                    return cls("moderate timbre")
                
                @schemas.classproperty
                def BRIGHT(cls):
                    return cls("bright")
                
                @schemas.classproperty
                def VERY_BRIGHT(cls):
                    return cls("very bright")
            
            
            class roughness(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "very clear": "VERY_CLEAR",
                        "clear": "CLEAR",
                        "moderate roughness": "MODERATE_ROUGHNESS",
                        "distorted": "DISTORTED",
                        "very distorted": "VERY_DISTORTED",
                    }
                
                @schemas.classproperty
                def VERY_CLEAR(cls):
                    return cls("very clear")
                
                @schemas.classproperty
                def CLEAR(cls):
                    return cls("clear")
                
                @schemas.classproperty
                def MODERATE_ROUGHNESS(cls):
                    return cls("moderate roughness")
                
                @schemas.classproperty
                def DISTORTED(cls):
                    return cls("distorted")
                
                @schemas.classproperty
                def VERY_DISTORTED(cls):
                    return cls("very distorted")
            
            
            class tonality(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "monotonous": "MONOTONOUS",
                        "moderate melodiousness": "MODERATE_MELODIOUSNESS",
                        "melodious": "MELODIOUS",
                        "atonal": "ATONAL",
                    }
                
                @schemas.classproperty
                def MONOTONOUS(cls):
                    return cls("monotonous")
                
                @schemas.classproperty
                def MODERATE_MELODIOUSNESS(cls):
                    return cls("moderate melodiousness")
                
                @schemas.classproperty
                def MELODIOUS(cls):
                    return cls("melodious")
                
                @schemas.classproperty
                def ATONAL(cls):
                    return cls("atonal")
            
            
            class harmony(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "very dissonant": "VERY_DISSONANT",
                        "dissonant": "DISSONANT",
                        "moderate harmonies": "MODERATE_HARMONIES",
                        "harmonious": "HARMONIOUS",
                        "very harmonious": "VERY_HARMONIOUS",
                    }
                
                @schemas.classproperty
                def VERY_DISSONANT(cls):
                    return cls("very dissonant")
                
                @schemas.classproperty
                def DISSONANT(cls):
                    return cls("dissonant")
                
                @schemas.classproperty
                def MODERATE_HARMONIES(cls):
                    return cls("moderate harmonies")
                
                @schemas.classproperty
                def HARMONIOUS(cls):
                    return cls("harmonious")
                
                @schemas.classproperty
                def VERY_HARMONIOUS(cls):
                    return cls("very harmonious")
            
            
            class texture(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "very thin": "VERY_THIN",
                        "thin": "THIN",
                        "moderate texture": "MODERATE_TEXTURE",
                        "full": "FULL",
                        "very full": "VERY_FULL",
                    }
                
                @schemas.classproperty
                def VERY_THIN(cls):
                    return cls("very thin")
                
                @schemas.classproperty
                def THIN(cls):
                    return cls("thin")
                
                @schemas.classproperty
                def MODERATE_TEXTURE(cls):
                    return cls("moderate texture")
                
                @schemas.classproperty
                def FULL(cls):
                    return cls("full")
                
                @schemas.classproperty
                def VERY_FULL(cls):
                    return cls("very full")
            
            
            class groovyness(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "very steady": "VERY_STEADY",
                        "steady": "STEADY",
                        "moderate rhythm feel": "MODERATE_RHYTHM_FEEL",
                        "groovy": "GROOVY",
                        "very groovy": "VERY_GROOVY",
                    }
                
                @schemas.classproperty
                def VERY_STEADY(cls):
                    return cls("very steady")
                
                @schemas.classproperty
                def STEADY(cls):
                    return cls("steady")
                
                @schemas.classproperty
                def MODERATE_RHYTHM_FEEL(cls):
                    return cls("moderate rhythm feel")
                
                @schemas.classproperty
                def GROOVY(cls):
                    return cls("groovy")
                
                @schemas.classproperty
                def VERY_GROOVY(cls):
                    return cls("very groovy")
            
            
            class space(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "very compact": "VERY_COMPACT",
                        "compact": "COMPACT",
                        "moderate space": "MODERATE_SPACE",
                        "wide": "WIDE",
                        "very wide": "VERY_WIDE",
                    }
                
                @schemas.classproperty
                def VERY_COMPACT(cls):
                    return cls("very compact")
                
                @schemas.classproperty
                def COMPACT(cls):
                    return cls("compact")
                
                @schemas.classproperty
                def MODERATE_SPACE(cls):
                    return cls("moderate space")
                
                @schemas.classproperty
                def WIDE(cls):
                    return cls("wide")
                
                @schemas.classproperty
                def VERY_WIDE(cls):
                    return cls("very wide")
            bpm = schemas.Float32Schema
            
            
            class key(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "C": "C",
                        "C#": "C",
                        "D": "D",
                        "D#": "D",
                        "E": "E",
                        "F": "F",
                        "F#": "F",
                        "G": "G",
                        "G#": "G",
                        "A": "A",
                        "A#": "A",
                        "B": "B",
                        "unclear": "UNCLEAR",
                    }
                
                @schemas.classproperty
                def C(cls):
                    return cls("C")
                
                @schemas.classproperty
                def C(cls):
                    return cls("C#")
                
                @schemas.classproperty
                def D(cls):
                    return cls("D")
                
                @schemas.classproperty
                def D(cls):
                    return cls("D#")
                
                @schemas.classproperty
                def E(cls):
                    return cls("E")
                
                @schemas.classproperty
                def F(cls):
                    return cls("F")
                
                @schemas.classproperty
                def F(cls):
                    return cls("F#")
                
                @schemas.classproperty
                def G(cls):
                    return cls("G")
                
                @schemas.classproperty
                def G(cls):
                    return cls("G#")
                
                @schemas.classproperty
                def A(cls):
                    return cls("A")
                
                @schemas.classproperty
                def A(cls):
                    return cls("A#")
                
                @schemas.classproperty
                def B(cls):
                    return cls("B")
                
                @schemas.classproperty
                def UNCLEAR(cls):
                    return cls("unclear")
            keyAffinity = schemas.Float32Schema
            
            
            class productionRating(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "low production quality": "LOW_PRODUCTION_QUALITY",
                        "medium production quality": "MEDIUM_PRODUCTION_QUALITY",
                        "high production quality": "HIGH_PRODUCTION_QUALITY",
                    }
                
                @schemas.classproperty
                def LOW_PRODUCTION_QUALITY(cls):
                    return cls("low production quality")
                
                @schemas.classproperty
                def MEDIUM_PRODUCTION_QUALITY(cls):
                    return cls("medium production quality")
                
                @schemas.classproperty
                def HIGH_PRODUCTION_QUALITY(cls):
                    return cls("high production quality")
            productionRatingAffinity = schemas.Float32Schema
            
            
            class performanceRating(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "low performance quality": "LOW_PERFORMANCE_QUALITY",
                        "medium performance quality": "MEDIUM_PERFORMANCE_QUALITY",
                        "high performance quality": "HIGH_PERFORMANCE_QUALITY",
                    }
                
                @schemas.classproperty
                def LOW_PERFORMANCE_QUALITY(cls):
                    return cls("low performance quality")
                
                @schemas.classproperty
                def MEDIUM_PERFORMANCE_QUALITY(cls):
                    return cls("medium performance quality")
                
                @schemas.classproperty
                def HIGH_PERFORMANCE_QUALITY(cls):
                    return cls("high performance quality")
            performanceRatingAffinity = schemas.Float32Schema
            
            
            class songRating(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "low song quality": "LOW_SONG_QUALITY",
                        "medium song quality": "MEDIUM_SONG_QUALITY",
                        "high song quality": "HIGH_SONG_QUALITY",
                    }
                
                @schemas.classproperty
                def LOW_SONG_QUALITY(cls):
                    return cls("low song quality")
                
                @schemas.classproperty
                def MEDIUM_SONG_QUALITY(cls):
                    return cls("medium song quality")
                
                @schemas.classproperty
                def HIGH_SONG_QUALITY(cls):
                    return cls("high song quality")
            songRatingAffinity = schemas.Float32Schema
            
            
            class audienceGender(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "male": "MALE",
                        "female": "FEMALE",
                    }
                
                @schemas.classproperty
                def MALE(cls):
                    return cls("male")
                
                @schemas.classproperty
                def FEMALE(cls):
                    return cls("female")
            audienceGenderAffinity = schemas.Float32Schema
            
            
            class audienceRegion(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "Australia and New Zealand": "AUSTRALIA_AND_NEW_ZEALAND",
                        "Central America and the Carribean": "CENTRAL_AMERICA_AND_THE_CARRIBEAN",
                        "Central and Southern Asia": "CENTRAL_AND_SOUTHERN_ASIA",
                        "Eastern Asia": "EASTERN_ASIA",
                        "Eastern Europe": "EASTERN_EUROPE",
                        "Northern Africa and Western Asia": "NORTHERN_AFRICA_AND_WESTERN_ASIA",
                        "Northern America": "NORTHERN_AMERICA",
                        "Oceania": "OCEANIA",
                        "South America": "SOUTH_AMERICA",
                        "South-Eastern Asia": "SOUTHEASTERN_ASIA",
                        "Southern Europe": "SOUTHERN_EUROPE",
                        "Sub-Saharan Africa": "SUBSAHARAN_AFRICA",
                        "Western and Northern Europe": "WESTERN_AND_NORTHERN_EUROPE",
                    }
                
                @schemas.classproperty
                def AUSTRALIA_AND_NEW_ZEALAND(cls):
                    return cls("Australia and New Zealand")
                
                @schemas.classproperty
                def CENTRAL_AMERICA_AND_THE_CARRIBEAN(cls):
                    return cls("Central America and the Carribean")
                
                @schemas.classproperty
                def CENTRAL_AND_SOUTHERN_ASIA(cls):
                    return cls("Central and Southern Asia")
                
                @schemas.classproperty
                def EASTERN_ASIA(cls):
                    return cls("Eastern Asia")
                
                @schemas.classproperty
                def EASTERN_EUROPE(cls):
                    return cls("Eastern Europe")
                
                @schemas.classproperty
                def NORTHERN_AFRICA_AND_WESTERN_ASIA(cls):
                    return cls("Northern Africa and Western Asia")
                
                @schemas.classproperty
                def NORTHERN_AMERICA(cls):
                    return cls("Northern America")
                
                @schemas.classproperty
                def OCEANIA(cls):
                    return cls("Oceania")
                
                @schemas.classproperty
                def SOUTH_AMERICA(cls):
                    return cls("South America")
                
                @schemas.classproperty
                def SOUTHEASTERN_ASIA(cls):
                    return cls("South-Eastern Asia")
                
                @schemas.classproperty
                def SOUTHERN_EUROPE(cls):
                    return cls("Southern Europe")
                
                @schemas.classproperty
                def SUBSAHARAN_AFRICA(cls):
                    return cls("Sub-Saharan Africa")
                
                @schemas.classproperty
                def WESTERN_AND_NORTHERN_EUROPE(cls):
                    return cls("Western and Northern Europe")
            audienceRegionAffinity = schemas.Float32Schema
            secondaryAudienceRegionAffinity = schemas.Float32Schema
            
            
            class secondaryAudienceRegion(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "Australia and New Zealand": "AUSTRALIA_AND_NEW_ZEALAND",
                        "Central America and the Carribean": "CENTRAL_AMERICA_AND_THE_CARRIBEAN",
                        "Central and Southern Asia": "CENTRAL_AND_SOUTHERN_ASIA",
                        "Eastern Asia": "EASTERN_ASIA",
                        "Eastern Europe": "EASTERN_EUROPE",
                        "Northern Africa and Western Asia": "NORTHERN_AFRICA_AND_WESTERN_ASIA",
                        "Northern America": "NORTHERN_AMERICA",
                        "Oceania": "OCEANIA",
                        "South America": "SOUTH_AMERICA",
                        "South-Eastern Asia": "SOUTHEASTERN_ASIA",
                        "Southern Europe": "SOUTHERN_EUROPE",
                        "Sub-Saharan Africa": "SUBSAHARAN_AFRICA",
                        "Western and Northern Europe": "WESTERN_AND_NORTHERN_EUROPE",
                    }
                
                @schemas.classproperty
                def AUSTRALIA_AND_NEW_ZEALAND(cls):
                    return cls("Australia and New Zealand")
                
                @schemas.classproperty
                def CENTRAL_AMERICA_AND_THE_CARRIBEAN(cls):
                    return cls("Central America and the Carribean")
                
                @schemas.classproperty
                def CENTRAL_AND_SOUTHERN_ASIA(cls):
                    return cls("Central and Southern Asia")
                
                @schemas.classproperty
                def EASTERN_ASIA(cls):
                    return cls("Eastern Asia")
                
                @schemas.classproperty
                def EASTERN_EUROPE(cls):
                    return cls("Eastern Europe")
                
                @schemas.classproperty
                def NORTHERN_AFRICA_AND_WESTERN_ASIA(cls):
                    return cls("Northern Africa and Western Asia")
                
                @schemas.classproperty
                def NORTHERN_AMERICA(cls):
                    return cls("Northern America")
                
                @schemas.classproperty
                def OCEANIA(cls):
                    return cls("Oceania")
                
                @schemas.classproperty
                def SOUTH_AMERICA(cls):
                    return cls("South America")
                
                @schemas.classproperty
                def SOUTHEASTERN_ASIA(cls):
                    return cls("South-Eastern Asia")
                
                @schemas.classproperty
                def SOUTHERN_EUROPE(cls):
                    return cls("Southern Europe")
                
                @schemas.classproperty
                def SUBSAHARAN_AFRICA(cls):
                    return cls("Sub-Saharan Africa")
                
                @schemas.classproperty
                def WESTERN_AND_NORTHERN_EUROPE(cls):
                    return cls("Western and Northern Europe")
            tertiaryAudienceRegionAffinity = schemas.Float32Schema
            
            
            class tertiaryAudienceRegion(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "Australia and New Zealand": "AUSTRALIA_AND_NEW_ZEALAND",
                        "Central America and the Carribean": "CENTRAL_AMERICA_AND_THE_CARRIBEAN",
                        "Central and Southern Asia": "CENTRAL_AND_SOUTHERN_ASIA",
                        "Eastern Asia": "EASTERN_ASIA",
                        "Eastern Europe": "EASTERN_EUROPE",
                        "Northern Africa and Western Asia": "NORTHERN_AFRICA_AND_WESTERN_ASIA",
                        "Northern America": "NORTHERN_AMERICA",
                        "Oceania": "OCEANIA",
                        "South America": "SOUTH_AMERICA",
                        "South-Eastern Asia": "SOUTHEASTERN_ASIA",
                        "Southern Europe": "SOUTHERN_EUROPE",
                        "Sub-Saharan Africa": "SUBSAHARAN_AFRICA",
                        "Western and Northern Europe": "WESTERN_AND_NORTHERN_EUROPE",
                    }
                
                @schemas.classproperty
                def AUSTRALIA_AND_NEW_ZEALAND(cls):
                    return cls("Australia and New Zealand")
                
                @schemas.classproperty
                def CENTRAL_AMERICA_AND_THE_CARRIBEAN(cls):
                    return cls("Central America and the Carribean")
                
                @schemas.classproperty
                def CENTRAL_AND_SOUTHERN_ASIA(cls):
                    return cls("Central and Southern Asia")
                
                @schemas.classproperty
                def EASTERN_ASIA(cls):
                    return cls("Eastern Asia")
                
                @schemas.classproperty
                def EASTERN_EUROPE(cls):
                    return cls("Eastern Europe")
                
                @schemas.classproperty
                def NORTHERN_AFRICA_AND_WESTERN_ASIA(cls):
                    return cls("Northern Africa and Western Asia")
                
                @schemas.classproperty
                def NORTHERN_AMERICA(cls):
                    return cls("Northern America")
                
                @schemas.classproperty
                def OCEANIA(cls):
                    return cls("Oceania")
                
                @schemas.classproperty
                def SOUTH_AMERICA(cls):
                    return cls("South America")
                
                @schemas.classproperty
                def SOUTHEASTERN_ASIA(cls):
                    return cls("South-Eastern Asia")
                
                @schemas.classproperty
                def SOUTHERN_EUROPE(cls):
                    return cls("Southern Europe")
                
                @schemas.classproperty
                def SUBSAHARAN_AFRICA(cls):
                    return cls("Sub-Saharan Africa")
                
                @schemas.classproperty
                def WESTERN_AND_NORTHERN_EUROPE(cls):
                    return cls("Western and Northern Europe")
            
            
            class audienceAge(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "Generation Z": "GENERATION_Z",
                        "Younger Generation Y": "YOUNGER_GENERATION_Y",
                        "Older Generation Y": "OLDER_GENERATION_Y",
                        "Generation X": "GENERATION_X",
                        "Younger Generation B": "YOUNGER_GENERATION_B",
                        "Older Generation B": "OLDER_GENERATION_B",
                    }
                
                @schemas.classproperty
                def GENERATION_Z(cls):
                    return cls("Generation Z")
                
                @schemas.classproperty
                def YOUNGER_GENERATION_Y(cls):
                    return cls("Younger Generation Y")
                
                @schemas.classproperty
                def OLDER_GENERATION_Y(cls):
                    return cls("Older Generation Y")
                
                @schemas.classproperty
                def GENERATION_X(cls):
                    return cls("Generation X")
                
                @schemas.classproperty
                def YOUNGER_GENERATION_B(cls):
                    return cls("Younger Generation B")
                
                @schemas.classproperty
                def OLDER_GENERATION_B(cls):
                    return cls("Older Generation B")
            audienceAgeAffinity = schemas.Float32Schema
            
            
            class secondaryAudienceAge(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "Generation Z": "GENERATION_Z",
                        "Younger Generation Y": "YOUNGER_GENERATION_Y",
                        "Older Generation Y": "OLDER_GENERATION_Y",
                        "Generation X": "GENERATION_X",
                        "Younger Generation B": "YOUNGER_GENERATION_B",
                        "Older Generation B": "OLDER_GENERATION_B",
                    }
                
                @schemas.classproperty
                def GENERATION_Z(cls):
                    return cls("Generation Z")
                
                @schemas.classproperty
                def YOUNGER_GENERATION_Y(cls):
                    return cls("Younger Generation Y")
                
                @schemas.classproperty
                def OLDER_GENERATION_Y(cls):
                    return cls("Older Generation Y")
                
                @schemas.classproperty
                def GENERATION_X(cls):
                    return cls("Generation X")
                
                @schemas.classproperty
                def YOUNGER_GENERATION_B(cls):
                    return cls("Younger Generation B")
                
                @schemas.classproperty
                def OLDER_GENERATION_B(cls):
                    return cls("Older Generation B")
            secondaryAudienceAgeAffinity = schemas.Float32Schema
            
            
            class tertiaryAudienceAge(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "Generation Z": "GENERATION_Z",
                        "Younger Generation Y": "YOUNGER_GENERATION_Y",
                        "Older Generation Y": "OLDER_GENERATION_Y",
                        "Generation X": "GENERATION_X",
                        "Younger Generation B": "YOUNGER_GENERATION_B",
                        "Older Generation B": "OLDER_GENERATION_B",
                    }
                
                @schemas.classproperty
                def GENERATION_Z(cls):
                    return cls("Generation Z")
                
                @schemas.classproperty
                def YOUNGER_GENERATION_Y(cls):
                    return cls("Younger Generation Y")
                
                @schemas.classproperty
                def OLDER_GENERATION_Y(cls):
                    return cls("Older Generation Y")
                
                @schemas.classproperty
                def GENERATION_X(cls):
                    return cls("Generation X")
                
                @schemas.classproperty
                def YOUNGER_GENERATION_B(cls):
                    return cls("Younger Generation B")
                
                @schemas.classproperty
                def OLDER_GENERATION_B(cls):
                    return cls("Older Generation B")
            tertiaryAudienceAgeAffinity = schemas.Float32Schema
            
            
            class originDecade(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "pre-1950s": "PRE1950S",
                        "1950s": "DIGIT_ONE_950S",
                        "1960s": "DIGIT_ONE_960S",
                        "1970s": "DIGIT_ONE_970S",
                        "1980s": "DIGIT_ONE_980S",
                        "1990s": "DIGIT_ONE_990S",
                        "2000s": "DIGIT_TWO_000S",
                        "2010s": "DIGIT_TWO_010S",
                        "2020s": "DIGIT_TWO_020S",
                    }
                
                @schemas.classproperty
                def PRE1950S(cls):
                    return cls("pre-1950s")
                
                @schemas.classproperty
                def DIGIT_ONE_950S(cls):
                    return cls("1950s")
                
                @schemas.classproperty
                def DIGIT_ONE_960S(cls):
                    return cls("1960s")
                
                @schemas.classproperty
                def DIGIT_ONE_970S(cls):
                    return cls("1970s")
                
                @schemas.classproperty
                def DIGIT_ONE_980S(cls):
                    return cls("1980s")
                
                @schemas.classproperty
                def DIGIT_ONE_990S(cls):
                    return cls("1990s")
                
                @schemas.classproperty
                def DIGIT_TWO_000S(cls):
                    return cls("2000s")
                
                @schemas.classproperty
                def DIGIT_TWO_010S(cls):
                    return cls("2010s")
                
                @schemas.classproperty
                def DIGIT_TWO_020S(cls):
                    return cls("2020s")
            originDecadeAffinity = schemas.Float32Schema
            
            
            class languageOfPerformance(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "en": "EN",
                        "de": "DE",
                        "no": "NO",
                        "fr": "FR",
                        "es": "ES",
                        "pt": "PT",
                        "fi": "FI",
                        "ru": "RU",
                        "it": "IT",
                        "la": "LA",
                        "el": "EL",
                        "ar": "AR",
                        "nl": "NL",
                        "ja": "JA",
                        "pl": "PL",
                        "sv": "SV",
                        "zu": "ZU",
                        "da": "DA",
                        "cs": "CS",
                        "hu": "HU",
                        "af": "AF",
                        "hi": "HI",
                        "tr": "TR",
                        "zh": "ZH",
                        "ms": "MS",
                        "pa": "PA",
                        "id": "ID",
                        "ko": "KO",
                        "vi": "VI",
                    }
                
                @schemas.classproperty
                def EN(cls):
                    return cls("en")
                
                @schemas.classproperty
                def DE(cls):
                    return cls("de")
                
                @schemas.classproperty
                def NO(cls):
                    return cls("no")
                
                @schemas.classproperty
                def FR(cls):
                    return cls("fr")
                
                @schemas.classproperty
                def ES(cls):
                    return cls("es")
                
                @schemas.classproperty
                def PT(cls):
                    return cls("pt")
                
                @schemas.classproperty
                def FI(cls):
                    return cls("fi")
                
                @schemas.classproperty
                def RU(cls):
                    return cls("ru")
                
                @schemas.classproperty
                def IT(cls):
                    return cls("it")
                
                @schemas.classproperty
                def LA(cls):
                    return cls("la")
                
                @schemas.classproperty
                def EL(cls):
                    return cls("el")
                
                @schemas.classproperty
                def AR(cls):
                    return cls("ar")
                
                @schemas.classproperty
                def NL(cls):
                    return cls("nl")
                
                @schemas.classproperty
                def JA(cls):
                    return cls("ja")
                
                @schemas.classproperty
                def PL(cls):
                    return cls("pl")
                
                @schemas.classproperty
                def SV(cls):
                    return cls("sv")
                
                @schemas.classproperty
                def ZU(cls):
                    return cls("zu")
                
                @schemas.classproperty
                def DA(cls):
                    return cls("da")
                
                @schemas.classproperty
                def CS(cls):
                    return cls("cs")
                
                @schemas.classproperty
                def HU(cls):
                    return cls("hu")
                
                @schemas.classproperty
                def AF(cls):
                    return cls("af")
                
                @schemas.classproperty
                def HI(cls):
                    return cls("hi")
                
                @schemas.classproperty
                def TR(cls):
                    return cls("tr")
                
                @schemas.classproperty
                def ZH(cls):
                    return cls("zh")
                
                @schemas.classproperty
                def MS(cls):
                    return cls("ms")
                
                @schemas.classproperty
                def PA(cls):
                    return cls("pa")
                
                @schemas.classproperty
                def ID(cls):
                    return cls("id")
                
                @schemas.classproperty
                def KO(cls):
                    return cls("ko")
                
                @schemas.classproperty
                def VI(cls):
                    return cls("vi")
            languageOfPerformanceAffinity = schemas.Float32Schema
            
            
            class originRegion(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "Australia and New Zealand": "AUSTRALIA_AND_NEW_ZEALAND",
                        "Central America and the Carribean": "CENTRAL_AMERICA_AND_THE_CARRIBEAN",
                        "Central and Southern Asia": "CENTRAL_AND_SOUTHERN_ASIA",
                        "Eastern Asia": "EASTERN_ASIA",
                        "Eastern Europe": "EASTERN_EUROPE",
                        "Northern Africa and Western Asia": "NORTHERN_AFRICA_AND_WESTERN_ASIA",
                        "Northern America": "NORTHERN_AMERICA",
                        "Oceania": "OCEANIA",
                        "South America": "SOUTH_AMERICA",
                        "South-Eastern Asia": "SOUTHEASTERN_ASIA",
                        "Southern Europe": "SOUTHERN_EUROPE",
                        "Sub-Saharan Africa": "SUBSAHARAN_AFRICA",
                        "Western and Northern Europe": "WESTERN_AND_NORTHERN_EUROPE",
                    }
                
                @schemas.classproperty
                def AUSTRALIA_AND_NEW_ZEALAND(cls):
                    return cls("Australia and New Zealand")
                
                @schemas.classproperty
                def CENTRAL_AMERICA_AND_THE_CARRIBEAN(cls):
                    return cls("Central America and the Carribean")
                
                @schemas.classproperty
                def CENTRAL_AND_SOUTHERN_ASIA(cls):
                    return cls("Central and Southern Asia")
                
                @schemas.classproperty
                def EASTERN_ASIA(cls):
                    return cls("Eastern Asia")
                
                @schemas.classproperty
                def EASTERN_EUROPE(cls):
                    return cls("Eastern Europe")
                
                @schemas.classproperty
                def NORTHERN_AFRICA_AND_WESTERN_ASIA(cls):
                    return cls("Northern Africa and Western Asia")
                
                @schemas.classproperty
                def NORTHERN_AMERICA(cls):
                    return cls("Northern America")
                
                @schemas.classproperty
                def OCEANIA(cls):
                    return cls("Oceania")
                
                @schemas.classproperty
                def SOUTH_AMERICA(cls):
                    return cls("South America")
                
                @schemas.classproperty
                def SOUTHEASTERN_ASIA(cls):
                    return cls("South-Eastern Asia")
                
                @schemas.classproperty
                def SOUTHERN_EUROPE(cls):
                    return cls("Southern Europe")
                
                @schemas.classproperty
                def SUBSAHARAN_AFRICA(cls):
                    return cls("Sub-Saharan Africa")
                
                @schemas.classproperty
                def WESTERN_AND_NORTHERN_EUROPE(cls):
                    return cls("Western and Northern Europe")
            originRegionAffinity = schemas.Float32Schema
        
            @staticmethod
            def taggrams() -> typing.Type['SaveTaggramsDTO']:
                return SaveTaggramsDTO
            
            
            class embeddings(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    items = schemas.Float32Schema
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple[typing.Union[MetaOapg.items, decimal.Decimal, int, float, ]], typing.List[typing.Union[MetaOapg.items, decimal.Decimal, int, float, ]]],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'embeddings':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> MetaOapg.items:
                    return super().__getitem__(i)
            
            
            class level1Genre(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "Pop": "POP",
                        "Rock": "ROCK",
                        "Metal": "METAL",
                        "Jazz": "JAZZ",
                        "World": "WORLD",
                        "Country": "COUNTRY",
                        "Functional Music": "FUNCTIONAL_MUSIC",
                        "Classical": "CLASSICAL",
                        "Alternative": "ALTERNATIVE",
                        "R&B": "RB",
                        "Blues": "BLUES",
                        "Hip Hop": "HIP_HOP",
                        "Reggae": "REGGAE",
                        "Electronic": "ELECTRONIC",
                        "Spoken Word": "SPOKEN_WORD",
                        "Folk": "FOLK",
                    }
                
                @schemas.classproperty
                def POP(cls):
                    return cls("Pop")
                
                @schemas.classproperty
                def ROCK(cls):
                    return cls("Rock")
                
                @schemas.classproperty
                def METAL(cls):
                    return cls("Metal")
                
                @schemas.classproperty
                def JAZZ(cls):
                    return cls("Jazz")
                
                @schemas.classproperty
                def WORLD(cls):
                    return cls("World")
                
                @schemas.classproperty
                def COUNTRY(cls):
                    return cls("Country")
                
                @schemas.classproperty
                def FUNCTIONAL_MUSIC(cls):
                    return cls("Functional Music")
                
                @schemas.classproperty
                def CLASSICAL(cls):
                    return cls("Classical")
                
                @schemas.classproperty
                def ALTERNATIVE(cls):
                    return cls("Alternative")
                
                @schemas.classproperty
                def RB(cls):
                    return cls("R&B")
                
                @schemas.classproperty
                def BLUES(cls):
                    return cls("Blues")
                
                @schemas.classproperty
                def HIP_HOP(cls):
                    return cls("Hip Hop")
                
                @schemas.classproperty
                def REGGAE(cls):
                    return cls("Reggae")
                
                @schemas.classproperty
                def ELECTRONIC(cls):
                    return cls("Electronic")
                
                @schemas.classproperty
                def SPOKEN_WORD(cls):
                    return cls("Spoken Word")
                
                @schemas.classproperty
                def FOLK(cls):
                    return cls("Folk")
            level1GenreAffinity = schemas.Float32Schema
            
            
            class secondaryLevel1Genre(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "Pop": "POP",
                        "Rock": "ROCK",
                        "Metal": "METAL",
                        "Jazz": "JAZZ",
                        "World": "WORLD",
                        "Country": "COUNTRY",
                        "Functional Music": "FUNCTIONAL_MUSIC",
                        "Classical": "CLASSICAL",
                        "Alternative": "ALTERNATIVE",
                        "R&B": "RB",
                        "Blues": "BLUES",
                        "Hip Hop": "HIP_HOP",
                        "Reggae": "REGGAE",
                        "Electronic": "ELECTRONIC",
                        "Spoken Word": "SPOKEN_WORD",
                        "Folk": "FOLK",
                    }
                
                @schemas.classproperty
                def POP(cls):
                    return cls("Pop")
                
                @schemas.classproperty
                def ROCK(cls):
                    return cls("Rock")
                
                @schemas.classproperty
                def METAL(cls):
                    return cls("Metal")
                
                @schemas.classproperty
                def JAZZ(cls):
                    return cls("Jazz")
                
                @schemas.classproperty
                def WORLD(cls):
                    return cls("World")
                
                @schemas.classproperty
                def COUNTRY(cls):
                    return cls("Country")
                
                @schemas.classproperty
                def FUNCTIONAL_MUSIC(cls):
                    return cls("Functional Music")
                
                @schemas.classproperty
                def CLASSICAL(cls):
                    return cls("Classical")
                
                @schemas.classproperty
                def ALTERNATIVE(cls):
                    return cls("Alternative")
                
                @schemas.classproperty
                def RB(cls):
                    return cls("R&B")
                
                @schemas.classproperty
                def BLUES(cls):
                    return cls("Blues")
                
                @schemas.classproperty
                def HIP_HOP(cls):
                    return cls("Hip Hop")
                
                @schemas.classproperty
                def REGGAE(cls):
                    return cls("Reggae")
                
                @schemas.classproperty
                def ELECTRONIC(cls):
                    return cls("Electronic")
                
                @schemas.classproperty
                def SPOKEN_WORD(cls):
                    return cls("Spoken Word")
                
                @schemas.classproperty
                def FOLK(cls):
                    return cls("Folk")
            secondaryLevel1GenreAffinity = schemas.Float32Schema
            
            
            class tertiaryLevel1Genre(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "Pop": "POP",
                        "Rock": "ROCK",
                        "Metal": "METAL",
                        "Jazz": "JAZZ",
                        "World": "WORLD",
                        "Country": "COUNTRY",
                        "Functional Music": "FUNCTIONAL_MUSIC",
                        "Classical": "CLASSICAL",
                        "Alternative": "ALTERNATIVE",
                        "R&B": "RB",
                        "Blues": "BLUES",
                        "Hip Hop": "HIP_HOP",
                        "Reggae": "REGGAE",
                        "Electronic": "ELECTRONIC",
                        "Spoken Word": "SPOKEN_WORD",
                        "Folk": "FOLK",
                    }
                
                @schemas.classproperty
                def POP(cls):
                    return cls("Pop")
                
                @schemas.classproperty
                def ROCK(cls):
                    return cls("Rock")
                
                @schemas.classproperty
                def METAL(cls):
                    return cls("Metal")
                
                @schemas.classproperty
                def JAZZ(cls):
                    return cls("Jazz")
                
                @schemas.classproperty
                def WORLD(cls):
                    return cls("World")
                
                @schemas.classproperty
                def COUNTRY(cls):
                    return cls("Country")
                
                @schemas.classproperty
                def FUNCTIONAL_MUSIC(cls):
                    return cls("Functional Music")
                
                @schemas.classproperty
                def CLASSICAL(cls):
                    return cls("Classical")
                
                @schemas.classproperty
                def ALTERNATIVE(cls):
                    return cls("Alternative")
                
                @schemas.classproperty
                def RB(cls):
                    return cls("R&B")
                
                @schemas.classproperty
                def BLUES(cls):
                    return cls("Blues")
                
                @schemas.classproperty
                def HIP_HOP(cls):
                    return cls("Hip Hop")
                
                @schemas.classproperty
                def REGGAE(cls):
                    return cls("Reggae")
                
                @schemas.classproperty
                def ELECTRONIC(cls):
                    return cls("Electronic")
                
                @schemas.classproperty
                def SPOKEN_WORD(cls):
                    return cls("Spoken Word")
                
                @schemas.classproperty
                def FOLK(cls):
                    return cls("Folk")
            tertiaryLevel1GenreAffinity = schemas.Float32Schema
            
            
            class level2Genre(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "Electro Pop": "ELECTRO_POP",
                        "Indie Pop": "INDIE_POP",
                        "Indie Rock": "INDIE_ROCK",
                        "Electroclash": "ELECTROCLASH",
                        "Adult Contemporary": "ADULT_CONTEMPORARY",
                        "Easy Listening": "EASY_LISTENING",
                        "Comedy Music": "COMEDY_MUSIC",
                        "New Age": "NEW_AGE",
                        "Chanson": "CHANSON",
                        "Singer/Songwriter": "SINGER_SONGWRITER",
                        "Schlager": "SCHLAGER",
                        "Volksmusik": "VOLKSMUSIK",
                        "Rock'n'Roll": "ROCKNROLL",
                        "Rockabilly": "ROCKABILLY",
                        "Psychobilly": "PSYCHOBILLY",
                        "Surf": "SURF",
                        "Doo Wop": "DOO_WOP",
                        "Mainstream Rock": "MAINSTREAM_ROCK",
                        "Mersey Beat": "MERSEY_BEAT",
                        "Glamrock": "GLAMROCK",
                        "Latin Rock": "LATIN_ROCK",
                        "Melodic Rock": "MELODIC_ROCK",
                        "Progressive Rock": "PROGRESSIVE_ROCK",
                        "Psychedelic Rock": "PSYCHEDELIC_ROCK",
                        "Hard Rock": "HARD_ROCK",
                        "Krautrock": "KRAUTROCK",
                        "Power Metal": "POWER_METAL",
                        "Nu Metal": "NU_METAL",
                        "Grind Core": "GRIND_CORE",
                        "Gothic Metal": "GOTHIC_METAL",
                        "Death Metal": "DEATH_METAL",
                        "Melodic Death Metal": "MELODIC_DEATH_METAL",
                        "Thrash Metal": "THRASH_METAL",
                        "Black Metal": "BLACK_METAL",
                        "Glam Metal": "GLAM_METAL",
                        "Sleaze Metal": "SLEAZE_METAL",
                        "Metalcore": "METALCORE",
                        "Progressive Metal": "PROGRESSIVE_METAL",
                        "Screamo": "SCREAMO",
                        "Symphonic Metal": "SYMPHONIC_METAL",
                        "Swing": "SWING",
                        "Ragtime": "RAGTIME",
                        "Dixieland": "DIXIELAND",
                        "Boogie Woogie": "BOOGIE_WOOGIE",
                        "Bebop": "BEBOP",
                        "Cool Jazz": "COOL_JAZZ",
                        "Free Jazz": "FREE_JAZZ",
                        "Fusion": "FUSION",
                        "Smooth Jazz": "SMOOTH_JAZZ",
                        "Acid Jazz": "ACID_JAZZ",
                        "Bossa Nova": "BOSSA_NOVA",
                        "Latin Jazz": "LATIN_JAZZ",
                        "Nu-Jazz": "NUJAZZ",
                        "Tango": "TANGO",
                        "Samba": "SAMBA",
                        "Salsa": "SALSA",
                        "Axé": "AX",
                        "Sertanejo": "SERTANEJO",
                        "Forró": "FORR",
                        "Choro": "CHORO",
                        "Fado": "FADO",
                        "Flamenco": "FLAMENCO",
                        "Blasmusik": "BLASMUSIK",
                        "American Folk": "AMERICAN_FOLK",
                        "Irish Folk": "IRISH_FOLK",
                        "Americana": "AMERICANA",
                        "Bluegrass": "BLUEGRASS",
                        "Red Dirt": "RED_DIRT",
                        "Outlaw Country": "OUTLAW_COUNTRY",
                        "Nashville": "NASHVILLE",
                        "Honkytonk": "HONKYTONK",
                        "Production Music": "PRODUCTION_MUSIC",
                        "Soundtrack": "SOUNDTRACK",
                        "Musical": "MUSICAL",
                        "Medieval": "MEDIEVAL",
                        "Renaissance": "RENAISSANCE",
                        "Baroque": "BAROQUE",
                        "Classical Period": "CLASSICAL_PERIOD",
                        "Romanticism": "ROMANTICISM",
                        "Neue Musik": "NEUE_MUSIK",
                        "Minimal Music": "MINIMAL_MUSIC",
                        "Neoklassik": "NEOKLASSIK",
                        "Postmoderne Musik": "POSTMODERNE_MUSIK",
                        "Punk": "PUNK",
                        "Noise Rock": "NOISE_ROCK",
                        "Garage": "GARAGE",
                        "Grunge": "GRUNGE",
                        "Industrial": "INDUSTRIAL",
                        "New Wave": "NEW_WAVE",
                        "Post Punk": "POST_PUNK",
                        "Gothic Rock": "GOTHIC_ROCK",
                        "Stoner Rock": "STONER_ROCK",
                        "Pop Punk": "POP_PUNK",
                        "Post Hardcore": "POST_HARDCORE",
                        "Post Rock": "POST_ROCK",
                        "Post Metal": "POST_METAL",
                        "Post-Grunge": "POSTGRUNGE",
                        "Britpop": "BRITPOP",
                        "Ska Punk": "SKA_PUNK",
                        "Math Rock": "MATH_ROCK",
                        "Dreampop": "DREAMPOP",
                        "Shoegaze": "SHOEGAZE",
                        "Contemporary R&B": "CONTEMPORARY_RB",
                        "Rhythm And Blues": "RHYTHM_AND_BLUES",
                        "Disco": "DISCO",
                        "Chicago Soul": "CHICAGO_SOUL",
                        "Detroit Soul": "DETROIT_SOUL",
                        "Urban": "URBAN",
                        "Nu R&B": "NU_RB",
                        "Neo Soul": "NEO_SOUL",
                        "Early Funk": "EARLY_FUNK",
                        "Funk Rock": "FUNK_ROCK",
                        "Folk Blues": "FOLK_BLUES",
                        "Classics Blues": "CLASSICS_BLUES",
                        "Blues Rock": "BLUES_ROCK",
                        "Trap Music": "TRAP_MUSIC",
                        "Electro-hop": "ELECTROHOP",
                        "Hardcore Rap": "HARDCORE_RAP",
                        "Miami Bass & Bounce": "MIAMI_BASS__BOUNCE",
                        "Dirty South Rap": "DIRTY_SOUTH_RAP",
                        "Turntablism": "TURNTABLISM",
                        "West Coast Gangsta Rap": "WEST_COAST_GANGSTA_RAP",
                        "East Coast Gangsta Rap": "EAST_COAST_GANGSTA_RAP",
                        "Roots-Reggae": "ROOTSREGGAE",
                        "Dub": "DUB",
                        "Raggamuffin": "RAGGAMUFFIN",
                        "Ska": "SKA",
                        "Dancehall": "DANCEHALL",
                        "Chicago House": "CHICAGO_HOUSE",
                        "Ambient House": "AMBIENT_HOUSE",
                        "Deep House": "DEEP_HOUSE",
                        "Tech House": "TECH_HOUSE",
                        "Acid House": "ACID_HOUSE",
                        "Dutch House": "DUTCH_HOUSE",
                        "Progressive House": "PROGRESSIVE_HOUSE",
                        "Funky House": "FUNKY_HOUSE",
                        "Nu Disco": "NU_DISCO",
                        "Minimal Techno": "MINIMAL_TECHNO",
                        "Hardcore Techno": "HARDCORE_TECHNO",
                        "IDM": "IDM",
                        "Trance": "TRANCE",
                        "Psytrance": "PSYTRANCE",
                        "Progressive Trance": "PROGRESSIVE_TRANCE",
                        "Grime": "GRIME",
                        "Big Beat": "BIG_BEAT",
                        "Dub Step": "DUB_STEP",
                        "Liquid Funk": "LIQUID_FUNK",
                        "Hard Step": "HARD_STEP",
                        "Jump Up": "JUMP_UP",
                        "Old School Jungle": "OLD_SCHOOL_JUNGLE",
                        "Trip Hop": "TRIP_HOP",
                        "Gospel": "GOSPEL",
                        "Dancepop": "DANCEPOP",
                        "Indietronica": "INDIETRONICA",
                        "Nu Rave": "NU_RAVE",
                        "Emo-Rock": "EMOROCK",
                        "Post-Punk Revival": "POSTPUNK_REVIVAL",
                        "Nu Prog": "NU_PROG",
                        "Indie Folk": "INDIE_FOLK",
                        "Audiobook": "AUDIOBOOK",
                        "Audioplay": "AUDIOPLAY",
                        "Relaxation": "RELAXATION",
                        "Ambient House / Chill-Out": "AMBIENT_HOUSE___CHILLOUT",
                        "Chemical Breaks & Big Beat": "CHEMICAL_BREAKS__BIG_BEAT",
                        "Chicago House & Garage House": "CHICAGO_HOUSE__GARAGE_HOUSE",
                        "Chicago Soul & Detroit Soul": "CHICAGO_SOUL__DETROIT_SOUL",
                        "Comedy": "COMEDY",
                        "Dark Wave": "DARK_WAVE",
                        "Dreampop & Shoegaze": "DREAMPOP__SHOEGAZE",
                        "Electro House & Dutch House": "ELECTRO_HOUSE__DUTCH_HOUSE",
                        "French House & Funky House": "FRENCH_HOUSE__FUNKY_HOUSE",
                        "Golden Age Rad & Hardcore Rap": "GOLDEN_AGE_RAD__HARDCORE_RAP",
                        "Hard Step & Tech Step": "HARD_STEP__TECH_STEP",
                        "Indietronica & Chillwave": "INDIETRONICA__CHILLWAVE",
                        "Nu Disco & Funktronica": "NU_DISCO__FUNKTRONICA",
                        "Doom Metal": "DOOM_METAL",
                        "Mathcore": "MATHCORE",
                        "Psy Trance": "PSY_TRANCE",
                        "Roots Rock": "ROOTS_ROCK",
                    }
                
                @schemas.classproperty
                def ELECTRO_POP(cls):
                    return cls("Electro Pop")
                
                @schemas.classproperty
                def INDIE_POP(cls):
                    return cls("Indie Pop")
                
                @schemas.classproperty
                def INDIE_ROCK(cls):
                    return cls("Indie Rock")
                
                @schemas.classproperty
                def ELECTROCLASH(cls):
                    return cls("Electroclash")
                
                @schemas.classproperty
                def ADULT_CONTEMPORARY(cls):
                    return cls("Adult Contemporary")
                
                @schemas.classproperty
                def EASY_LISTENING(cls):
                    return cls("Easy Listening")
                
                @schemas.classproperty
                def COMEDY_MUSIC(cls):
                    return cls("Comedy Music")
                
                @schemas.classproperty
                def NEW_AGE(cls):
                    return cls("New Age")
                
                @schemas.classproperty
                def CHANSON(cls):
                    return cls("Chanson")
                
                @schemas.classproperty
                def SINGER_SONGWRITER(cls):
                    return cls("Singer/Songwriter")
                
                @schemas.classproperty
                def SCHLAGER(cls):
                    return cls("Schlager")
                
                @schemas.classproperty
                def VOLKSMUSIK(cls):
                    return cls("Volksmusik")
                
                @schemas.classproperty
                def ROCKNROLL(cls):
                    return cls("Rock'n'Roll")
                
                @schemas.classproperty
                def ROCKABILLY(cls):
                    return cls("Rockabilly")
                
                @schemas.classproperty
                def PSYCHOBILLY(cls):
                    return cls("Psychobilly")
                
                @schemas.classproperty
                def SURF(cls):
                    return cls("Surf")
                
                @schemas.classproperty
                def DOO_WOP(cls):
                    return cls("Doo Wop")
                
                @schemas.classproperty
                def MAINSTREAM_ROCK(cls):
                    return cls("Mainstream Rock")
                
                @schemas.classproperty
                def MERSEY_BEAT(cls):
                    return cls("Mersey Beat")
                
                @schemas.classproperty
                def GLAMROCK(cls):
                    return cls("Glamrock")
                
                @schemas.classproperty
                def LATIN_ROCK(cls):
                    return cls("Latin Rock")
                
                @schemas.classproperty
                def MELODIC_ROCK(cls):
                    return cls("Melodic Rock")
                
                @schemas.classproperty
                def PROGRESSIVE_ROCK(cls):
                    return cls("Progressive Rock")
                
                @schemas.classproperty
                def PSYCHEDELIC_ROCK(cls):
                    return cls("Psychedelic Rock")
                
                @schemas.classproperty
                def HARD_ROCK(cls):
                    return cls("Hard Rock")
                
                @schemas.classproperty
                def KRAUTROCK(cls):
                    return cls("Krautrock")
                
                @schemas.classproperty
                def POWER_METAL(cls):
                    return cls("Power Metal")
                
                @schemas.classproperty
                def NU_METAL(cls):
                    return cls("Nu Metal")
                
                @schemas.classproperty
                def GRIND_CORE(cls):
                    return cls("Grind Core")
                
                @schemas.classproperty
                def GOTHIC_METAL(cls):
                    return cls("Gothic Metal")
                
                @schemas.classproperty
                def DEATH_METAL(cls):
                    return cls("Death Metal")
                
                @schemas.classproperty
                def MELODIC_DEATH_METAL(cls):
                    return cls("Melodic Death Metal")
                
                @schemas.classproperty
                def THRASH_METAL(cls):
                    return cls("Thrash Metal")
                
                @schemas.classproperty
                def BLACK_METAL(cls):
                    return cls("Black Metal")
                
                @schemas.classproperty
                def GLAM_METAL(cls):
                    return cls("Glam Metal")
                
                @schemas.classproperty
                def SLEAZE_METAL(cls):
                    return cls("Sleaze Metal")
                
                @schemas.classproperty
                def METALCORE(cls):
                    return cls("Metalcore")
                
                @schemas.classproperty
                def PROGRESSIVE_METAL(cls):
                    return cls("Progressive Metal")
                
                @schemas.classproperty
                def SCREAMO(cls):
                    return cls("Screamo")
                
                @schemas.classproperty
                def SYMPHONIC_METAL(cls):
                    return cls("Symphonic Metal")
                
                @schemas.classproperty
                def SWING(cls):
                    return cls("Swing")
                
                @schemas.classproperty
                def RAGTIME(cls):
                    return cls("Ragtime")
                
                @schemas.classproperty
                def DIXIELAND(cls):
                    return cls("Dixieland")
                
                @schemas.classproperty
                def BOOGIE_WOOGIE(cls):
                    return cls("Boogie Woogie")
                
                @schemas.classproperty
                def BEBOP(cls):
                    return cls("Bebop")
                
                @schemas.classproperty
                def COOL_JAZZ(cls):
                    return cls("Cool Jazz")
                
                @schemas.classproperty
                def FREE_JAZZ(cls):
                    return cls("Free Jazz")
                
                @schemas.classproperty
                def FUSION(cls):
                    return cls("Fusion")
                
                @schemas.classproperty
                def SMOOTH_JAZZ(cls):
                    return cls("Smooth Jazz")
                
                @schemas.classproperty
                def ACID_JAZZ(cls):
                    return cls("Acid Jazz")
                
                @schemas.classproperty
                def BOSSA_NOVA(cls):
                    return cls("Bossa Nova")
                
                @schemas.classproperty
                def LATIN_JAZZ(cls):
                    return cls("Latin Jazz")
                
                @schemas.classproperty
                def NUJAZZ(cls):
                    return cls("Nu-Jazz")
                
                @schemas.classproperty
                def TANGO(cls):
                    return cls("Tango")
                
                @schemas.classproperty
                def SAMBA(cls):
                    return cls("Samba")
                
                @schemas.classproperty
                def SALSA(cls):
                    return cls("Salsa")
                
                @schemas.classproperty
                def AX(cls):
                    return cls("Axé")
                
                @schemas.classproperty
                def SERTANEJO(cls):
                    return cls("Sertanejo")
                
                @schemas.classproperty
                def FORR(cls):
                    return cls("Forró")
                
                @schemas.classproperty
                def CHORO(cls):
                    return cls("Choro")
                
                @schemas.classproperty
                def FADO(cls):
                    return cls("Fado")
                
                @schemas.classproperty
                def FLAMENCO(cls):
                    return cls("Flamenco")
                
                @schemas.classproperty
                def BLASMUSIK(cls):
                    return cls("Blasmusik")
                
                @schemas.classproperty
                def AMERICAN_FOLK(cls):
                    return cls("American Folk")
                
                @schemas.classproperty
                def IRISH_FOLK(cls):
                    return cls("Irish Folk")
                
                @schemas.classproperty
                def AMERICANA(cls):
                    return cls("Americana")
                
                @schemas.classproperty
                def BLUEGRASS(cls):
                    return cls("Bluegrass")
                
                @schemas.classproperty
                def RED_DIRT(cls):
                    return cls("Red Dirt")
                
                @schemas.classproperty
                def OUTLAW_COUNTRY(cls):
                    return cls("Outlaw Country")
                
                @schemas.classproperty
                def NASHVILLE(cls):
                    return cls("Nashville")
                
                @schemas.classproperty
                def HONKYTONK(cls):
                    return cls("Honkytonk")
                
                @schemas.classproperty
                def PRODUCTION_MUSIC(cls):
                    return cls("Production Music")
                
                @schemas.classproperty
                def SOUNDTRACK(cls):
                    return cls("Soundtrack")
                
                @schemas.classproperty
                def MUSICAL(cls):
                    return cls("Musical")
                
                @schemas.classproperty
                def MEDIEVAL(cls):
                    return cls("Medieval")
                
                @schemas.classproperty
                def RENAISSANCE(cls):
                    return cls("Renaissance")
                
                @schemas.classproperty
                def BAROQUE(cls):
                    return cls("Baroque")
                
                @schemas.classproperty
                def CLASSICAL_PERIOD(cls):
                    return cls("Classical Period")
                
                @schemas.classproperty
                def ROMANTICISM(cls):
                    return cls("Romanticism")
                
                @schemas.classproperty
                def NEUE_MUSIK(cls):
                    return cls("Neue Musik")
                
                @schemas.classproperty
                def MINIMAL_MUSIC(cls):
                    return cls("Minimal Music")
                
                @schemas.classproperty
                def NEOKLASSIK(cls):
                    return cls("Neoklassik")
                
                @schemas.classproperty
                def POSTMODERNE_MUSIK(cls):
                    return cls("Postmoderne Musik")
                
                @schemas.classproperty
                def PUNK(cls):
                    return cls("Punk")
                
                @schemas.classproperty
                def NOISE_ROCK(cls):
                    return cls("Noise Rock")
                
                @schemas.classproperty
                def GARAGE(cls):
                    return cls("Garage")
                
                @schemas.classproperty
                def GRUNGE(cls):
                    return cls("Grunge")
                
                @schemas.classproperty
                def INDUSTRIAL(cls):
                    return cls("Industrial")
                
                @schemas.classproperty
                def NEW_WAVE(cls):
                    return cls("New Wave")
                
                @schemas.classproperty
                def POST_PUNK(cls):
                    return cls("Post Punk")
                
                @schemas.classproperty
                def GOTHIC_ROCK(cls):
                    return cls("Gothic Rock")
                
                @schemas.classproperty
                def STONER_ROCK(cls):
                    return cls("Stoner Rock")
                
                @schemas.classproperty
                def POP_PUNK(cls):
                    return cls("Pop Punk")
                
                @schemas.classproperty
                def POST_HARDCORE(cls):
                    return cls("Post Hardcore")
                
                @schemas.classproperty
                def POST_ROCK(cls):
                    return cls("Post Rock")
                
                @schemas.classproperty
                def POST_METAL(cls):
                    return cls("Post Metal")
                
                @schemas.classproperty
                def POSTGRUNGE(cls):
                    return cls("Post-Grunge")
                
                @schemas.classproperty
                def BRITPOP(cls):
                    return cls("Britpop")
                
                @schemas.classproperty
                def SKA_PUNK(cls):
                    return cls("Ska Punk")
                
                @schemas.classproperty
                def MATH_ROCK(cls):
                    return cls("Math Rock")
                
                @schemas.classproperty
                def DREAMPOP(cls):
                    return cls("Dreampop")
                
                @schemas.classproperty
                def SHOEGAZE(cls):
                    return cls("Shoegaze")
                
                @schemas.classproperty
                def CONTEMPORARY_RB(cls):
                    return cls("Contemporary R&B")
                
                @schemas.classproperty
                def RHYTHM_AND_BLUES(cls):
                    return cls("Rhythm And Blues")
                
                @schemas.classproperty
                def DISCO(cls):
                    return cls("Disco")
                
                @schemas.classproperty
                def CHICAGO_SOUL(cls):
                    return cls("Chicago Soul")
                
                @schemas.classproperty
                def DETROIT_SOUL(cls):
                    return cls("Detroit Soul")
                
                @schemas.classproperty
                def URBAN(cls):
                    return cls("Urban")
                
                @schemas.classproperty
                def NU_RB(cls):
                    return cls("Nu R&B")
                
                @schemas.classproperty
                def NEO_SOUL(cls):
                    return cls("Neo Soul")
                
                @schemas.classproperty
                def EARLY_FUNK(cls):
                    return cls("Early Funk")
                
                @schemas.classproperty
                def FUNK_ROCK(cls):
                    return cls("Funk Rock")
                
                @schemas.classproperty
                def FOLK_BLUES(cls):
                    return cls("Folk Blues")
                
                @schemas.classproperty
                def CLASSICS_BLUES(cls):
                    return cls("Classics Blues")
                
                @schemas.classproperty
                def BLUES_ROCK(cls):
                    return cls("Blues Rock")
                
                @schemas.classproperty
                def TRAP_MUSIC(cls):
                    return cls("Trap Music")
                
                @schemas.classproperty
                def ELECTROHOP(cls):
                    return cls("Electro-hop")
                
                @schemas.classproperty
                def HARDCORE_RAP(cls):
                    return cls("Hardcore Rap")
                
                @schemas.classproperty
                def MIAMI_BASS__BOUNCE(cls):
                    return cls("Miami Bass & Bounce")
                
                @schemas.classproperty
                def DIRTY_SOUTH_RAP(cls):
                    return cls("Dirty South Rap")
                
                @schemas.classproperty
                def TURNTABLISM(cls):
                    return cls("Turntablism")
                
                @schemas.classproperty
                def WEST_COAST_GANGSTA_RAP(cls):
                    return cls("West Coast Gangsta Rap")
                
                @schemas.classproperty
                def EAST_COAST_GANGSTA_RAP(cls):
                    return cls("East Coast Gangsta Rap")
                
                @schemas.classproperty
                def ROOTSREGGAE(cls):
                    return cls("Roots-Reggae")
                
                @schemas.classproperty
                def DUB(cls):
                    return cls("Dub")
                
                @schemas.classproperty
                def RAGGAMUFFIN(cls):
                    return cls("Raggamuffin")
                
                @schemas.classproperty
                def SKA(cls):
                    return cls("Ska")
                
                @schemas.classproperty
                def DANCEHALL(cls):
                    return cls("Dancehall")
                
                @schemas.classproperty
                def CHICAGO_HOUSE(cls):
                    return cls("Chicago House")
                
                @schemas.classproperty
                def AMBIENT_HOUSE(cls):
                    return cls("Ambient House")
                
                @schemas.classproperty
                def DEEP_HOUSE(cls):
                    return cls("Deep House")
                
                @schemas.classproperty
                def TECH_HOUSE(cls):
                    return cls("Tech House")
                
                @schemas.classproperty
                def ACID_HOUSE(cls):
                    return cls("Acid House")
                
                @schemas.classproperty
                def DUTCH_HOUSE(cls):
                    return cls("Dutch House")
                
                @schemas.classproperty
                def PROGRESSIVE_HOUSE(cls):
                    return cls("Progressive House")
                
                @schemas.classproperty
                def FUNKY_HOUSE(cls):
                    return cls("Funky House")
                
                @schemas.classproperty
                def NU_DISCO(cls):
                    return cls("Nu Disco")
                
                @schemas.classproperty
                def MINIMAL_TECHNO(cls):
                    return cls("Minimal Techno")
                
                @schemas.classproperty
                def HARDCORE_TECHNO(cls):
                    return cls("Hardcore Techno")
                
                @schemas.classproperty
                def IDM(cls):
                    return cls("IDM")
                
                @schemas.classproperty
                def TRANCE(cls):
                    return cls("Trance")
                
                @schemas.classproperty
                def PSYTRANCE(cls):
                    return cls("Psytrance")
                
                @schemas.classproperty
                def PROGRESSIVE_TRANCE(cls):
                    return cls("Progressive Trance")
                
                @schemas.classproperty
                def GRIME(cls):
                    return cls("Grime")
                
                @schemas.classproperty
                def BIG_BEAT(cls):
                    return cls("Big Beat")
                
                @schemas.classproperty
                def DUB_STEP(cls):
                    return cls("Dub Step")
                
                @schemas.classproperty
                def LIQUID_FUNK(cls):
                    return cls("Liquid Funk")
                
                @schemas.classproperty
                def HARD_STEP(cls):
                    return cls("Hard Step")
                
                @schemas.classproperty
                def JUMP_UP(cls):
                    return cls("Jump Up")
                
                @schemas.classproperty
                def OLD_SCHOOL_JUNGLE(cls):
                    return cls("Old School Jungle")
                
                @schemas.classproperty
                def TRIP_HOP(cls):
                    return cls("Trip Hop")
                
                @schemas.classproperty
                def GOSPEL(cls):
                    return cls("Gospel")
                
                @schemas.classproperty
                def DANCEPOP(cls):
                    return cls("Dancepop")
                
                @schemas.classproperty
                def INDIETRONICA(cls):
                    return cls("Indietronica")
                
                @schemas.classproperty
                def NU_RAVE(cls):
                    return cls("Nu Rave")
                
                @schemas.classproperty
                def EMOROCK(cls):
                    return cls("Emo-Rock")
                
                @schemas.classproperty
                def POSTPUNK_REVIVAL(cls):
                    return cls("Post-Punk Revival")
                
                @schemas.classproperty
                def NU_PROG(cls):
                    return cls("Nu Prog")
                
                @schemas.classproperty
                def INDIE_FOLK(cls):
                    return cls("Indie Folk")
                
                @schemas.classproperty
                def AUDIOBOOK(cls):
                    return cls("Audiobook")
                
                @schemas.classproperty
                def AUDIOPLAY(cls):
                    return cls("Audioplay")
                
                @schemas.classproperty
                def RELAXATION(cls):
                    return cls("Relaxation")
                
                @schemas.classproperty
                def AMBIENT_HOUSE___CHILLOUT(cls):
                    return cls("Ambient House / Chill-Out")
                
                @schemas.classproperty
                def CHEMICAL_BREAKS__BIG_BEAT(cls):
                    return cls("Chemical Breaks & Big Beat")
                
                @schemas.classproperty
                def CHICAGO_HOUSE__GARAGE_HOUSE(cls):
                    return cls("Chicago House & Garage House")
                
                @schemas.classproperty
                def CHICAGO_SOUL__DETROIT_SOUL(cls):
                    return cls("Chicago Soul & Detroit Soul")
                
                @schemas.classproperty
                def COMEDY(cls):
                    return cls("Comedy")
                
                @schemas.classproperty
                def DARK_WAVE(cls):
                    return cls("Dark Wave")
                
                @schemas.classproperty
                def DREAMPOP__SHOEGAZE(cls):
                    return cls("Dreampop & Shoegaze")
                
                @schemas.classproperty
                def ELECTRO_HOUSE__DUTCH_HOUSE(cls):
                    return cls("Electro House & Dutch House")
                
                @schemas.classproperty
                def FRENCH_HOUSE__FUNKY_HOUSE(cls):
                    return cls("French House & Funky House")
                
                @schemas.classproperty
                def GOLDEN_AGE_RAD__HARDCORE_RAP(cls):
                    return cls("Golden Age Rad & Hardcore Rap")
                
                @schemas.classproperty
                def HARD_STEP__TECH_STEP(cls):
                    return cls("Hard Step & Tech Step")
                
                @schemas.classproperty
                def INDIETRONICA__CHILLWAVE(cls):
                    return cls("Indietronica & Chillwave")
                
                @schemas.classproperty
                def NU_DISCO__FUNKTRONICA(cls):
                    return cls("Nu Disco & Funktronica")
                
                @schemas.classproperty
                def DOOM_METAL(cls):
                    return cls("Doom Metal")
                
                @schemas.classproperty
                def MATHCORE(cls):
                    return cls("Mathcore")
                
                @schemas.classproperty
                def PSY_TRANCE(cls):
                    return cls("Psy Trance")
                
                @schemas.classproperty
                def ROOTS_ROCK(cls):
                    return cls("Roots Rock")
            level2GenreAffinity = schemas.Float32Schema
            
            
            class secondaryLevel2Genre(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "Electro Pop": "ELECTRO_POP",
                        "Indie Pop": "INDIE_POP",
                        "Indie Rock": "INDIE_ROCK",
                        "Electroclash": "ELECTROCLASH",
                        "Adult Contemporary": "ADULT_CONTEMPORARY",
                        "Easy Listening": "EASY_LISTENING",
                        "Comedy Music": "COMEDY_MUSIC",
                        "New Age": "NEW_AGE",
                        "Chanson": "CHANSON",
                        "Singer/Songwriter": "SINGER_SONGWRITER",
                        "Schlager": "SCHLAGER",
                        "Volksmusik": "VOLKSMUSIK",
                        "Rock'n'Roll": "ROCKNROLL",
                        "Rockabilly": "ROCKABILLY",
                        "Psychobilly": "PSYCHOBILLY",
                        "Surf": "SURF",
                        "Doo Wop": "DOO_WOP",
                        "Mainstream Rock": "MAINSTREAM_ROCK",
                        "Mersey Beat": "MERSEY_BEAT",
                        "Glamrock": "GLAMROCK",
                        "Latin Rock": "LATIN_ROCK",
                        "Melodic Rock": "MELODIC_ROCK",
                        "Progressive Rock": "PROGRESSIVE_ROCK",
                        "Psychedelic Rock": "PSYCHEDELIC_ROCK",
                        "Hard Rock": "HARD_ROCK",
                        "Krautrock": "KRAUTROCK",
                        "Power Metal": "POWER_METAL",
                        "Nu Metal": "NU_METAL",
                        "Grind Core": "GRIND_CORE",
                        "Gothic Metal": "GOTHIC_METAL",
                        "Death Metal": "DEATH_METAL",
                        "Melodic Death Metal": "MELODIC_DEATH_METAL",
                        "Thrash Metal": "THRASH_METAL",
                        "Black Metal": "BLACK_METAL",
                        "Glam Metal": "GLAM_METAL",
                        "Sleaze Metal": "SLEAZE_METAL",
                        "Metalcore": "METALCORE",
                        "Progressive Metal": "PROGRESSIVE_METAL",
                        "Screamo": "SCREAMO",
                        "Symphonic Metal": "SYMPHONIC_METAL",
                        "Swing": "SWING",
                        "Ragtime": "RAGTIME",
                        "Dixieland": "DIXIELAND",
                        "Boogie Woogie": "BOOGIE_WOOGIE",
                        "Bebop": "BEBOP",
                        "Cool Jazz": "COOL_JAZZ",
                        "Free Jazz": "FREE_JAZZ",
                        "Fusion": "FUSION",
                        "Smooth Jazz": "SMOOTH_JAZZ",
                        "Acid Jazz": "ACID_JAZZ",
                        "Bossa Nova": "BOSSA_NOVA",
                        "Latin Jazz": "LATIN_JAZZ",
                        "Nu-Jazz": "NUJAZZ",
                        "Tango": "TANGO",
                        "Samba": "SAMBA",
                        "Salsa": "SALSA",
                        "Axé": "AX",
                        "Sertanejo": "SERTANEJO",
                        "Forró": "FORR",
                        "Choro": "CHORO",
                        "Fado": "FADO",
                        "Flamenco": "FLAMENCO",
                        "Blasmusik": "BLASMUSIK",
                        "American Folk": "AMERICAN_FOLK",
                        "Irish Folk": "IRISH_FOLK",
                        "Americana": "AMERICANA",
                        "Bluegrass": "BLUEGRASS",
                        "Red Dirt": "RED_DIRT",
                        "Outlaw Country": "OUTLAW_COUNTRY",
                        "Nashville": "NASHVILLE",
                        "Honkytonk": "HONKYTONK",
                        "Production Music": "PRODUCTION_MUSIC",
                        "Soundtrack": "SOUNDTRACK",
                        "Musical": "MUSICAL",
                        "Medieval": "MEDIEVAL",
                        "Renaissance": "RENAISSANCE",
                        "Baroque": "BAROQUE",
                        "Classical Period": "CLASSICAL_PERIOD",
                        "Romanticism": "ROMANTICISM",
                        "Neue Musik": "NEUE_MUSIK",
                        "Minimal Music": "MINIMAL_MUSIC",
                        "Neoklassik": "NEOKLASSIK",
                        "Postmoderne Musik": "POSTMODERNE_MUSIK",
                        "Punk": "PUNK",
                        "Noise Rock": "NOISE_ROCK",
                        "Garage": "GARAGE",
                        "Grunge": "GRUNGE",
                        "Industrial": "INDUSTRIAL",
                        "New Wave": "NEW_WAVE",
                        "Post Punk": "POST_PUNK",
                        "Gothic Rock": "GOTHIC_ROCK",
                        "Stoner Rock": "STONER_ROCK",
                        "Pop Punk": "POP_PUNK",
                        "Post Hardcore": "POST_HARDCORE",
                        "Post Rock": "POST_ROCK",
                        "Post Metal": "POST_METAL",
                        "Post-Grunge": "POSTGRUNGE",
                        "Britpop": "BRITPOP",
                        "Ska Punk": "SKA_PUNK",
                        "Math Rock": "MATH_ROCK",
                        "Dreampop": "DREAMPOP",
                        "Shoegaze": "SHOEGAZE",
                        "Contemporary R&B": "CONTEMPORARY_RB",
                        "Rhythm And Blues": "RHYTHM_AND_BLUES",
                        "Disco": "DISCO",
                        "Chicago Soul": "CHICAGO_SOUL",
                        "Detroit Soul": "DETROIT_SOUL",
                        "Urban": "URBAN",
                        "Nu R&B": "NU_RB",
                        "Neo Soul": "NEO_SOUL",
                        "Early Funk": "EARLY_FUNK",
                        "Funk Rock": "FUNK_ROCK",
                        "Folk Blues": "FOLK_BLUES",
                        "Classics Blues": "CLASSICS_BLUES",
                        "Blues Rock": "BLUES_ROCK",
                        "Trap Music": "TRAP_MUSIC",
                        "Electro-hop": "ELECTROHOP",
                        "Hardcore Rap": "HARDCORE_RAP",
                        "Miami Bass & Bounce": "MIAMI_BASS__BOUNCE",
                        "Dirty South Rap": "DIRTY_SOUTH_RAP",
                        "Turntablism": "TURNTABLISM",
                        "West Coast Gangsta Rap": "WEST_COAST_GANGSTA_RAP",
                        "East Coast Gangsta Rap": "EAST_COAST_GANGSTA_RAP",
                        "Roots-Reggae": "ROOTSREGGAE",
                        "Dub": "DUB",
                        "Raggamuffin": "RAGGAMUFFIN",
                        "Ska": "SKA",
                        "Dancehall": "DANCEHALL",
                        "Chicago House": "CHICAGO_HOUSE",
                        "Ambient House": "AMBIENT_HOUSE",
                        "Deep House": "DEEP_HOUSE",
                        "Tech House": "TECH_HOUSE",
                        "Acid House": "ACID_HOUSE",
                        "Dutch House": "DUTCH_HOUSE",
                        "Progressive House": "PROGRESSIVE_HOUSE",
                        "Funky House": "FUNKY_HOUSE",
                        "Nu Disco": "NU_DISCO",
                        "Minimal Techno": "MINIMAL_TECHNO",
                        "Hardcore Techno": "HARDCORE_TECHNO",
                        "IDM": "IDM",
                        "Trance": "TRANCE",
                        "Psytrance": "PSYTRANCE",
                        "Progressive Trance": "PROGRESSIVE_TRANCE",
                        "Grime": "GRIME",
                        "Big Beat": "BIG_BEAT",
                        "Dub Step": "DUB_STEP",
                        "Liquid Funk": "LIQUID_FUNK",
                        "Hard Step": "HARD_STEP",
                        "Jump Up": "JUMP_UP",
                        "Old School Jungle": "OLD_SCHOOL_JUNGLE",
                        "Trip Hop": "TRIP_HOP",
                        "Gospel": "GOSPEL",
                        "Dancepop": "DANCEPOP",
                        "Indietronica": "INDIETRONICA",
                        "Nu Rave": "NU_RAVE",
                        "Emo-Rock": "EMOROCK",
                        "Post-Punk Revival": "POSTPUNK_REVIVAL",
                        "Nu Prog": "NU_PROG",
                        "Indie Folk": "INDIE_FOLK",
                        "Audiobook": "AUDIOBOOK",
                        "Audioplay": "AUDIOPLAY",
                        "Relaxation": "RELAXATION",
                        "Ambient House / Chill-Out": "AMBIENT_HOUSE___CHILLOUT",
                        "Chemical Breaks & Big Beat": "CHEMICAL_BREAKS__BIG_BEAT",
                        "Chicago House & Garage House": "CHICAGO_HOUSE__GARAGE_HOUSE",
                        "Chicago Soul & Detroit Soul": "CHICAGO_SOUL__DETROIT_SOUL",
                        "Comedy": "COMEDY",
                        "Dark Wave": "DARK_WAVE",
                        "Dreampop & Shoegaze": "DREAMPOP__SHOEGAZE",
                        "Electro House & Dutch House": "ELECTRO_HOUSE__DUTCH_HOUSE",
                        "French House & Funky House": "FRENCH_HOUSE__FUNKY_HOUSE",
                        "Golden Age Rad & Hardcore Rap": "GOLDEN_AGE_RAD__HARDCORE_RAP",
                        "Hard Step & Tech Step": "HARD_STEP__TECH_STEP",
                        "Indietronica & Chillwave": "INDIETRONICA__CHILLWAVE",
                        "Nu Disco & Funktronica": "NU_DISCO__FUNKTRONICA",
                        "Doom Metal": "DOOM_METAL",
                        "Mathcore": "MATHCORE",
                        "Psy Trance": "PSY_TRANCE",
                        "Roots Rock": "ROOTS_ROCK",
                    }
                
                @schemas.classproperty
                def ELECTRO_POP(cls):
                    return cls("Electro Pop")
                
                @schemas.classproperty
                def INDIE_POP(cls):
                    return cls("Indie Pop")
                
                @schemas.classproperty
                def INDIE_ROCK(cls):
                    return cls("Indie Rock")
                
                @schemas.classproperty
                def ELECTROCLASH(cls):
                    return cls("Electroclash")
                
                @schemas.classproperty
                def ADULT_CONTEMPORARY(cls):
                    return cls("Adult Contemporary")
                
                @schemas.classproperty
                def EASY_LISTENING(cls):
                    return cls("Easy Listening")
                
                @schemas.classproperty
                def COMEDY_MUSIC(cls):
                    return cls("Comedy Music")
                
                @schemas.classproperty
                def NEW_AGE(cls):
                    return cls("New Age")
                
                @schemas.classproperty
                def CHANSON(cls):
                    return cls("Chanson")
                
                @schemas.classproperty
                def SINGER_SONGWRITER(cls):
                    return cls("Singer/Songwriter")
                
                @schemas.classproperty
                def SCHLAGER(cls):
                    return cls("Schlager")
                
                @schemas.classproperty
                def VOLKSMUSIK(cls):
                    return cls("Volksmusik")
                
                @schemas.classproperty
                def ROCKNROLL(cls):
                    return cls("Rock'n'Roll")
                
                @schemas.classproperty
                def ROCKABILLY(cls):
                    return cls("Rockabilly")
                
                @schemas.classproperty
                def PSYCHOBILLY(cls):
                    return cls("Psychobilly")
                
                @schemas.classproperty
                def SURF(cls):
                    return cls("Surf")
                
                @schemas.classproperty
                def DOO_WOP(cls):
                    return cls("Doo Wop")
                
                @schemas.classproperty
                def MAINSTREAM_ROCK(cls):
                    return cls("Mainstream Rock")
                
                @schemas.classproperty
                def MERSEY_BEAT(cls):
                    return cls("Mersey Beat")
                
                @schemas.classproperty
                def GLAMROCK(cls):
                    return cls("Glamrock")
                
                @schemas.classproperty
                def LATIN_ROCK(cls):
                    return cls("Latin Rock")
                
                @schemas.classproperty
                def MELODIC_ROCK(cls):
                    return cls("Melodic Rock")
                
                @schemas.classproperty
                def PROGRESSIVE_ROCK(cls):
                    return cls("Progressive Rock")
                
                @schemas.classproperty
                def PSYCHEDELIC_ROCK(cls):
                    return cls("Psychedelic Rock")
                
                @schemas.classproperty
                def HARD_ROCK(cls):
                    return cls("Hard Rock")
                
                @schemas.classproperty
                def KRAUTROCK(cls):
                    return cls("Krautrock")
                
                @schemas.classproperty
                def POWER_METAL(cls):
                    return cls("Power Metal")
                
                @schemas.classproperty
                def NU_METAL(cls):
                    return cls("Nu Metal")
                
                @schemas.classproperty
                def GRIND_CORE(cls):
                    return cls("Grind Core")
                
                @schemas.classproperty
                def GOTHIC_METAL(cls):
                    return cls("Gothic Metal")
                
                @schemas.classproperty
                def DEATH_METAL(cls):
                    return cls("Death Metal")
                
                @schemas.classproperty
                def MELODIC_DEATH_METAL(cls):
                    return cls("Melodic Death Metal")
                
                @schemas.classproperty
                def THRASH_METAL(cls):
                    return cls("Thrash Metal")
                
                @schemas.classproperty
                def BLACK_METAL(cls):
                    return cls("Black Metal")
                
                @schemas.classproperty
                def GLAM_METAL(cls):
                    return cls("Glam Metal")
                
                @schemas.classproperty
                def SLEAZE_METAL(cls):
                    return cls("Sleaze Metal")
                
                @schemas.classproperty
                def METALCORE(cls):
                    return cls("Metalcore")
                
                @schemas.classproperty
                def PROGRESSIVE_METAL(cls):
                    return cls("Progressive Metal")
                
                @schemas.classproperty
                def SCREAMO(cls):
                    return cls("Screamo")
                
                @schemas.classproperty
                def SYMPHONIC_METAL(cls):
                    return cls("Symphonic Metal")
                
                @schemas.classproperty
                def SWING(cls):
                    return cls("Swing")
                
                @schemas.classproperty
                def RAGTIME(cls):
                    return cls("Ragtime")
                
                @schemas.classproperty
                def DIXIELAND(cls):
                    return cls("Dixieland")
                
                @schemas.classproperty
                def BOOGIE_WOOGIE(cls):
                    return cls("Boogie Woogie")
                
                @schemas.classproperty
                def BEBOP(cls):
                    return cls("Bebop")
                
                @schemas.classproperty
                def COOL_JAZZ(cls):
                    return cls("Cool Jazz")
                
                @schemas.classproperty
                def FREE_JAZZ(cls):
                    return cls("Free Jazz")
                
                @schemas.classproperty
                def FUSION(cls):
                    return cls("Fusion")
                
                @schemas.classproperty
                def SMOOTH_JAZZ(cls):
                    return cls("Smooth Jazz")
                
                @schemas.classproperty
                def ACID_JAZZ(cls):
                    return cls("Acid Jazz")
                
                @schemas.classproperty
                def BOSSA_NOVA(cls):
                    return cls("Bossa Nova")
                
                @schemas.classproperty
                def LATIN_JAZZ(cls):
                    return cls("Latin Jazz")
                
                @schemas.classproperty
                def NUJAZZ(cls):
                    return cls("Nu-Jazz")
                
                @schemas.classproperty
                def TANGO(cls):
                    return cls("Tango")
                
                @schemas.classproperty
                def SAMBA(cls):
                    return cls("Samba")
                
                @schemas.classproperty
                def SALSA(cls):
                    return cls("Salsa")
                
                @schemas.classproperty
                def AX(cls):
                    return cls("Axé")
                
                @schemas.classproperty
                def SERTANEJO(cls):
                    return cls("Sertanejo")
                
                @schemas.classproperty
                def FORR(cls):
                    return cls("Forró")
                
                @schemas.classproperty
                def CHORO(cls):
                    return cls("Choro")
                
                @schemas.classproperty
                def FADO(cls):
                    return cls("Fado")
                
                @schemas.classproperty
                def FLAMENCO(cls):
                    return cls("Flamenco")
                
                @schemas.classproperty
                def BLASMUSIK(cls):
                    return cls("Blasmusik")
                
                @schemas.classproperty
                def AMERICAN_FOLK(cls):
                    return cls("American Folk")
                
                @schemas.classproperty
                def IRISH_FOLK(cls):
                    return cls("Irish Folk")
                
                @schemas.classproperty
                def AMERICANA(cls):
                    return cls("Americana")
                
                @schemas.classproperty
                def BLUEGRASS(cls):
                    return cls("Bluegrass")
                
                @schemas.classproperty
                def RED_DIRT(cls):
                    return cls("Red Dirt")
                
                @schemas.classproperty
                def OUTLAW_COUNTRY(cls):
                    return cls("Outlaw Country")
                
                @schemas.classproperty
                def NASHVILLE(cls):
                    return cls("Nashville")
                
                @schemas.classproperty
                def HONKYTONK(cls):
                    return cls("Honkytonk")
                
                @schemas.classproperty
                def PRODUCTION_MUSIC(cls):
                    return cls("Production Music")
                
                @schemas.classproperty
                def SOUNDTRACK(cls):
                    return cls("Soundtrack")
                
                @schemas.classproperty
                def MUSICAL(cls):
                    return cls("Musical")
                
                @schemas.classproperty
                def MEDIEVAL(cls):
                    return cls("Medieval")
                
                @schemas.classproperty
                def RENAISSANCE(cls):
                    return cls("Renaissance")
                
                @schemas.classproperty
                def BAROQUE(cls):
                    return cls("Baroque")
                
                @schemas.classproperty
                def CLASSICAL_PERIOD(cls):
                    return cls("Classical Period")
                
                @schemas.classproperty
                def ROMANTICISM(cls):
                    return cls("Romanticism")
                
                @schemas.classproperty
                def NEUE_MUSIK(cls):
                    return cls("Neue Musik")
                
                @schemas.classproperty
                def MINIMAL_MUSIC(cls):
                    return cls("Minimal Music")
                
                @schemas.classproperty
                def NEOKLASSIK(cls):
                    return cls("Neoklassik")
                
                @schemas.classproperty
                def POSTMODERNE_MUSIK(cls):
                    return cls("Postmoderne Musik")
                
                @schemas.classproperty
                def PUNK(cls):
                    return cls("Punk")
                
                @schemas.classproperty
                def NOISE_ROCK(cls):
                    return cls("Noise Rock")
                
                @schemas.classproperty
                def GARAGE(cls):
                    return cls("Garage")
                
                @schemas.classproperty
                def GRUNGE(cls):
                    return cls("Grunge")
                
                @schemas.classproperty
                def INDUSTRIAL(cls):
                    return cls("Industrial")
                
                @schemas.classproperty
                def NEW_WAVE(cls):
                    return cls("New Wave")
                
                @schemas.classproperty
                def POST_PUNK(cls):
                    return cls("Post Punk")
                
                @schemas.classproperty
                def GOTHIC_ROCK(cls):
                    return cls("Gothic Rock")
                
                @schemas.classproperty
                def STONER_ROCK(cls):
                    return cls("Stoner Rock")
                
                @schemas.classproperty
                def POP_PUNK(cls):
                    return cls("Pop Punk")
                
                @schemas.classproperty
                def POST_HARDCORE(cls):
                    return cls("Post Hardcore")
                
                @schemas.classproperty
                def POST_ROCK(cls):
                    return cls("Post Rock")
                
                @schemas.classproperty
                def POST_METAL(cls):
                    return cls("Post Metal")
                
                @schemas.classproperty
                def POSTGRUNGE(cls):
                    return cls("Post-Grunge")
                
                @schemas.classproperty
                def BRITPOP(cls):
                    return cls("Britpop")
                
                @schemas.classproperty
                def SKA_PUNK(cls):
                    return cls("Ska Punk")
                
                @schemas.classproperty
                def MATH_ROCK(cls):
                    return cls("Math Rock")
                
                @schemas.classproperty
                def DREAMPOP(cls):
                    return cls("Dreampop")
                
                @schemas.classproperty
                def SHOEGAZE(cls):
                    return cls("Shoegaze")
                
                @schemas.classproperty
                def CONTEMPORARY_RB(cls):
                    return cls("Contemporary R&B")
                
                @schemas.classproperty
                def RHYTHM_AND_BLUES(cls):
                    return cls("Rhythm And Blues")
                
                @schemas.classproperty
                def DISCO(cls):
                    return cls("Disco")
                
                @schemas.classproperty
                def CHICAGO_SOUL(cls):
                    return cls("Chicago Soul")
                
                @schemas.classproperty
                def DETROIT_SOUL(cls):
                    return cls("Detroit Soul")
                
                @schemas.classproperty
                def URBAN(cls):
                    return cls("Urban")
                
                @schemas.classproperty
                def NU_RB(cls):
                    return cls("Nu R&B")
                
                @schemas.classproperty
                def NEO_SOUL(cls):
                    return cls("Neo Soul")
                
                @schemas.classproperty
                def EARLY_FUNK(cls):
                    return cls("Early Funk")
                
                @schemas.classproperty
                def FUNK_ROCK(cls):
                    return cls("Funk Rock")
                
                @schemas.classproperty
                def FOLK_BLUES(cls):
                    return cls("Folk Blues")
                
                @schemas.classproperty
                def CLASSICS_BLUES(cls):
                    return cls("Classics Blues")
                
                @schemas.classproperty
                def BLUES_ROCK(cls):
                    return cls("Blues Rock")
                
                @schemas.classproperty
                def TRAP_MUSIC(cls):
                    return cls("Trap Music")
                
                @schemas.classproperty
                def ELECTROHOP(cls):
                    return cls("Electro-hop")
                
                @schemas.classproperty
                def HARDCORE_RAP(cls):
                    return cls("Hardcore Rap")
                
                @schemas.classproperty
                def MIAMI_BASS__BOUNCE(cls):
                    return cls("Miami Bass & Bounce")
                
                @schemas.classproperty
                def DIRTY_SOUTH_RAP(cls):
                    return cls("Dirty South Rap")
                
                @schemas.classproperty
                def TURNTABLISM(cls):
                    return cls("Turntablism")
                
                @schemas.classproperty
                def WEST_COAST_GANGSTA_RAP(cls):
                    return cls("West Coast Gangsta Rap")
                
                @schemas.classproperty
                def EAST_COAST_GANGSTA_RAP(cls):
                    return cls("East Coast Gangsta Rap")
                
                @schemas.classproperty
                def ROOTSREGGAE(cls):
                    return cls("Roots-Reggae")
                
                @schemas.classproperty
                def DUB(cls):
                    return cls("Dub")
                
                @schemas.classproperty
                def RAGGAMUFFIN(cls):
                    return cls("Raggamuffin")
                
                @schemas.classproperty
                def SKA(cls):
                    return cls("Ska")
                
                @schemas.classproperty
                def DANCEHALL(cls):
                    return cls("Dancehall")
                
                @schemas.classproperty
                def CHICAGO_HOUSE(cls):
                    return cls("Chicago House")
                
                @schemas.classproperty
                def AMBIENT_HOUSE(cls):
                    return cls("Ambient House")
                
                @schemas.classproperty
                def DEEP_HOUSE(cls):
                    return cls("Deep House")
                
                @schemas.classproperty
                def TECH_HOUSE(cls):
                    return cls("Tech House")
                
                @schemas.classproperty
                def ACID_HOUSE(cls):
                    return cls("Acid House")
                
                @schemas.classproperty
                def DUTCH_HOUSE(cls):
                    return cls("Dutch House")
                
                @schemas.classproperty
                def PROGRESSIVE_HOUSE(cls):
                    return cls("Progressive House")
                
                @schemas.classproperty
                def FUNKY_HOUSE(cls):
                    return cls("Funky House")
                
                @schemas.classproperty
                def NU_DISCO(cls):
                    return cls("Nu Disco")
                
                @schemas.classproperty
                def MINIMAL_TECHNO(cls):
                    return cls("Minimal Techno")
                
                @schemas.classproperty
                def HARDCORE_TECHNO(cls):
                    return cls("Hardcore Techno")
                
                @schemas.classproperty
                def IDM(cls):
                    return cls("IDM")
                
                @schemas.classproperty
                def TRANCE(cls):
                    return cls("Trance")
                
                @schemas.classproperty
                def PSYTRANCE(cls):
                    return cls("Psytrance")
                
                @schemas.classproperty
                def PROGRESSIVE_TRANCE(cls):
                    return cls("Progressive Trance")
                
                @schemas.classproperty
                def GRIME(cls):
                    return cls("Grime")
                
                @schemas.classproperty
                def BIG_BEAT(cls):
                    return cls("Big Beat")
                
                @schemas.classproperty
                def DUB_STEP(cls):
                    return cls("Dub Step")
                
                @schemas.classproperty
                def LIQUID_FUNK(cls):
                    return cls("Liquid Funk")
                
                @schemas.classproperty
                def HARD_STEP(cls):
                    return cls("Hard Step")
                
                @schemas.classproperty
                def JUMP_UP(cls):
                    return cls("Jump Up")
                
                @schemas.classproperty
                def OLD_SCHOOL_JUNGLE(cls):
                    return cls("Old School Jungle")
                
                @schemas.classproperty
                def TRIP_HOP(cls):
                    return cls("Trip Hop")
                
                @schemas.classproperty
                def GOSPEL(cls):
                    return cls("Gospel")
                
                @schemas.classproperty
                def DANCEPOP(cls):
                    return cls("Dancepop")
                
                @schemas.classproperty
                def INDIETRONICA(cls):
                    return cls("Indietronica")
                
                @schemas.classproperty
                def NU_RAVE(cls):
                    return cls("Nu Rave")
                
                @schemas.classproperty
                def EMOROCK(cls):
                    return cls("Emo-Rock")
                
                @schemas.classproperty
                def POSTPUNK_REVIVAL(cls):
                    return cls("Post-Punk Revival")
                
                @schemas.classproperty
                def NU_PROG(cls):
                    return cls("Nu Prog")
                
                @schemas.classproperty
                def INDIE_FOLK(cls):
                    return cls("Indie Folk")
                
                @schemas.classproperty
                def AUDIOBOOK(cls):
                    return cls("Audiobook")
                
                @schemas.classproperty
                def AUDIOPLAY(cls):
                    return cls("Audioplay")
                
                @schemas.classproperty
                def RELAXATION(cls):
                    return cls("Relaxation")
                
                @schemas.classproperty
                def AMBIENT_HOUSE___CHILLOUT(cls):
                    return cls("Ambient House / Chill-Out")
                
                @schemas.classproperty
                def CHEMICAL_BREAKS__BIG_BEAT(cls):
                    return cls("Chemical Breaks & Big Beat")
                
                @schemas.classproperty
                def CHICAGO_HOUSE__GARAGE_HOUSE(cls):
                    return cls("Chicago House & Garage House")
                
                @schemas.classproperty
                def CHICAGO_SOUL__DETROIT_SOUL(cls):
                    return cls("Chicago Soul & Detroit Soul")
                
                @schemas.classproperty
                def COMEDY(cls):
                    return cls("Comedy")
                
                @schemas.classproperty
                def DARK_WAVE(cls):
                    return cls("Dark Wave")
                
                @schemas.classproperty
                def DREAMPOP__SHOEGAZE(cls):
                    return cls("Dreampop & Shoegaze")
                
                @schemas.classproperty
                def ELECTRO_HOUSE__DUTCH_HOUSE(cls):
                    return cls("Electro House & Dutch House")
                
                @schemas.classproperty
                def FRENCH_HOUSE__FUNKY_HOUSE(cls):
                    return cls("French House & Funky House")
                
                @schemas.classproperty
                def GOLDEN_AGE_RAD__HARDCORE_RAP(cls):
                    return cls("Golden Age Rad & Hardcore Rap")
                
                @schemas.classproperty
                def HARD_STEP__TECH_STEP(cls):
                    return cls("Hard Step & Tech Step")
                
                @schemas.classproperty
                def INDIETRONICA__CHILLWAVE(cls):
                    return cls("Indietronica & Chillwave")
                
                @schemas.classproperty
                def NU_DISCO__FUNKTRONICA(cls):
                    return cls("Nu Disco & Funktronica")
                
                @schemas.classproperty
                def DOOM_METAL(cls):
                    return cls("Doom Metal")
                
                @schemas.classproperty
                def MATHCORE(cls):
                    return cls("Mathcore")
                
                @schemas.classproperty
                def PSY_TRANCE(cls):
                    return cls("Psy Trance")
                
                @schemas.classproperty
                def ROOTS_ROCK(cls):
                    return cls("Roots Rock")
            secondaryLevel2GenreAffinity = schemas.Float32Schema
            
            
            class tertiaryLevel2Genre(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "Electro Pop": "ELECTRO_POP",
                        "Indie Pop": "INDIE_POP",
                        "Indie Rock": "INDIE_ROCK",
                        "Electroclash": "ELECTROCLASH",
                        "Adult Contemporary": "ADULT_CONTEMPORARY",
                        "Easy Listening": "EASY_LISTENING",
                        "Comedy Music": "COMEDY_MUSIC",
                        "New Age": "NEW_AGE",
                        "Chanson": "CHANSON",
                        "Singer/Songwriter": "SINGER_SONGWRITER",
                        "Schlager": "SCHLAGER",
                        "Volksmusik": "VOLKSMUSIK",
                        "Rock'n'Roll": "ROCKNROLL",
                        "Rockabilly": "ROCKABILLY",
                        "Psychobilly": "PSYCHOBILLY",
                        "Surf": "SURF",
                        "Doo Wop": "DOO_WOP",
                        "Mainstream Rock": "MAINSTREAM_ROCK",
                        "Mersey Beat": "MERSEY_BEAT",
                        "Glamrock": "GLAMROCK",
                        "Latin Rock": "LATIN_ROCK",
                        "Melodic Rock": "MELODIC_ROCK",
                        "Progressive Rock": "PROGRESSIVE_ROCK",
                        "Psychedelic Rock": "PSYCHEDELIC_ROCK",
                        "Hard Rock": "HARD_ROCK",
                        "Krautrock": "KRAUTROCK",
                        "Power Metal": "POWER_METAL",
                        "Nu Metal": "NU_METAL",
                        "Grind Core": "GRIND_CORE",
                        "Gothic Metal": "GOTHIC_METAL",
                        "Death Metal": "DEATH_METAL",
                        "Melodic Death Metal": "MELODIC_DEATH_METAL",
                        "Thrash Metal": "THRASH_METAL",
                        "Black Metal": "BLACK_METAL",
                        "Glam Metal": "GLAM_METAL",
                        "Sleaze Metal": "SLEAZE_METAL",
                        "Metalcore": "METALCORE",
                        "Progressive Metal": "PROGRESSIVE_METAL",
                        "Screamo": "SCREAMO",
                        "Symphonic Metal": "SYMPHONIC_METAL",
                        "Swing": "SWING",
                        "Ragtime": "RAGTIME",
                        "Dixieland": "DIXIELAND",
                        "Boogie Woogie": "BOOGIE_WOOGIE",
                        "Bebop": "BEBOP",
                        "Cool Jazz": "COOL_JAZZ",
                        "Free Jazz": "FREE_JAZZ",
                        "Fusion": "FUSION",
                        "Smooth Jazz": "SMOOTH_JAZZ",
                        "Acid Jazz": "ACID_JAZZ",
                        "Bossa Nova": "BOSSA_NOVA",
                        "Latin Jazz": "LATIN_JAZZ",
                        "Nu-Jazz": "NUJAZZ",
                        "Tango": "TANGO",
                        "Samba": "SAMBA",
                        "Salsa": "SALSA",
                        "Axé": "AX",
                        "Sertanejo": "SERTANEJO",
                        "Forró": "FORR",
                        "Choro": "CHORO",
                        "Fado": "FADO",
                        "Flamenco": "FLAMENCO",
                        "Blasmusik": "BLASMUSIK",
                        "American Folk": "AMERICAN_FOLK",
                        "Irish Folk": "IRISH_FOLK",
                        "Americana": "AMERICANA",
                        "Bluegrass": "BLUEGRASS",
                        "Red Dirt": "RED_DIRT",
                        "Outlaw Country": "OUTLAW_COUNTRY",
                        "Nashville": "NASHVILLE",
                        "Honkytonk": "HONKYTONK",
                        "Production Music": "PRODUCTION_MUSIC",
                        "Soundtrack": "SOUNDTRACK",
                        "Musical": "MUSICAL",
                        "Medieval": "MEDIEVAL",
                        "Renaissance": "RENAISSANCE",
                        "Baroque": "BAROQUE",
                        "Classical Period": "CLASSICAL_PERIOD",
                        "Romanticism": "ROMANTICISM",
                        "Neue Musik": "NEUE_MUSIK",
                        "Minimal Music": "MINIMAL_MUSIC",
                        "Neoklassik": "NEOKLASSIK",
                        "Postmoderne Musik": "POSTMODERNE_MUSIK",
                        "Punk": "PUNK",
                        "Noise Rock": "NOISE_ROCK",
                        "Garage": "GARAGE",
                        "Grunge": "GRUNGE",
                        "Industrial": "INDUSTRIAL",
                        "New Wave": "NEW_WAVE",
                        "Post Punk": "POST_PUNK",
                        "Gothic Rock": "GOTHIC_ROCK",
                        "Stoner Rock": "STONER_ROCK",
                        "Pop Punk": "POP_PUNK",
                        "Post Hardcore": "POST_HARDCORE",
                        "Post Rock": "POST_ROCK",
                        "Post Metal": "POST_METAL",
                        "Post-Grunge": "POSTGRUNGE",
                        "Britpop": "BRITPOP",
                        "Ska Punk": "SKA_PUNK",
                        "Math Rock": "MATH_ROCK",
                        "Dreampop": "DREAMPOP",
                        "Shoegaze": "SHOEGAZE",
                        "Contemporary R&B": "CONTEMPORARY_RB",
                        "Rhythm And Blues": "RHYTHM_AND_BLUES",
                        "Disco": "DISCO",
                        "Chicago Soul": "CHICAGO_SOUL",
                        "Detroit Soul": "DETROIT_SOUL",
                        "Urban": "URBAN",
                        "Nu R&B": "NU_RB",
                        "Neo Soul": "NEO_SOUL",
                        "Early Funk": "EARLY_FUNK",
                        "Funk Rock": "FUNK_ROCK",
                        "Folk Blues": "FOLK_BLUES",
                        "Classics Blues": "CLASSICS_BLUES",
                        "Blues Rock": "BLUES_ROCK",
                        "Trap Music": "TRAP_MUSIC",
                        "Electro-hop": "ELECTROHOP",
                        "Hardcore Rap": "HARDCORE_RAP",
                        "Miami Bass & Bounce": "MIAMI_BASS__BOUNCE",
                        "Dirty South Rap": "DIRTY_SOUTH_RAP",
                        "Turntablism": "TURNTABLISM",
                        "West Coast Gangsta Rap": "WEST_COAST_GANGSTA_RAP",
                        "East Coast Gangsta Rap": "EAST_COAST_GANGSTA_RAP",
                        "Roots-Reggae": "ROOTSREGGAE",
                        "Dub": "DUB",
                        "Raggamuffin": "RAGGAMUFFIN",
                        "Ska": "SKA",
                        "Dancehall": "DANCEHALL",
                        "Chicago House": "CHICAGO_HOUSE",
                        "Ambient House": "AMBIENT_HOUSE",
                        "Deep House": "DEEP_HOUSE",
                        "Tech House": "TECH_HOUSE",
                        "Acid House": "ACID_HOUSE",
                        "Dutch House": "DUTCH_HOUSE",
                        "Progressive House": "PROGRESSIVE_HOUSE",
                        "Funky House": "FUNKY_HOUSE",
                        "Nu Disco": "NU_DISCO",
                        "Minimal Techno": "MINIMAL_TECHNO",
                        "Hardcore Techno": "HARDCORE_TECHNO",
                        "IDM": "IDM",
                        "Trance": "TRANCE",
                        "Psytrance": "PSYTRANCE",
                        "Progressive Trance": "PROGRESSIVE_TRANCE",
                        "Grime": "GRIME",
                        "Big Beat": "BIG_BEAT",
                        "Dub Step": "DUB_STEP",
                        "Liquid Funk": "LIQUID_FUNK",
                        "Hard Step": "HARD_STEP",
                        "Jump Up": "JUMP_UP",
                        "Old School Jungle": "OLD_SCHOOL_JUNGLE",
                        "Trip Hop": "TRIP_HOP",
                        "Gospel": "GOSPEL",
                        "Dancepop": "DANCEPOP",
                        "Indietronica": "INDIETRONICA",
                        "Nu Rave": "NU_RAVE",
                        "Emo-Rock": "EMOROCK",
                        "Post-Punk Revival": "POSTPUNK_REVIVAL",
                        "Nu Prog": "NU_PROG",
                        "Indie Folk": "INDIE_FOLK",
                        "Audiobook": "AUDIOBOOK",
                        "Audioplay": "AUDIOPLAY",
                        "Relaxation": "RELAXATION",
                        "Ambient House / Chill-Out": "AMBIENT_HOUSE___CHILLOUT",
                        "Chemical Breaks & Big Beat": "CHEMICAL_BREAKS__BIG_BEAT",
                        "Chicago House & Garage House": "CHICAGO_HOUSE__GARAGE_HOUSE",
                        "Chicago Soul & Detroit Soul": "CHICAGO_SOUL__DETROIT_SOUL",
                        "Comedy": "COMEDY",
                        "Dark Wave": "DARK_WAVE",
                        "Dreampop & Shoegaze": "DREAMPOP__SHOEGAZE",
                        "Electro House & Dutch House": "ELECTRO_HOUSE__DUTCH_HOUSE",
                        "French House & Funky House": "FRENCH_HOUSE__FUNKY_HOUSE",
                        "Golden Age Rad & Hardcore Rap": "GOLDEN_AGE_RAD__HARDCORE_RAP",
                        "Hard Step & Tech Step": "HARD_STEP__TECH_STEP",
                        "Indietronica & Chillwave": "INDIETRONICA__CHILLWAVE",
                        "Nu Disco & Funktronica": "NU_DISCO__FUNKTRONICA",
                        "Doom Metal": "DOOM_METAL",
                        "Mathcore": "MATHCORE",
                        "Psy Trance": "PSY_TRANCE",
                        "Roots Rock": "ROOTS_ROCK",
                    }
                
                @schemas.classproperty
                def ELECTRO_POP(cls):
                    return cls("Electro Pop")
                
                @schemas.classproperty
                def INDIE_POP(cls):
                    return cls("Indie Pop")
                
                @schemas.classproperty
                def INDIE_ROCK(cls):
                    return cls("Indie Rock")
                
                @schemas.classproperty
                def ELECTROCLASH(cls):
                    return cls("Electroclash")
                
                @schemas.classproperty
                def ADULT_CONTEMPORARY(cls):
                    return cls("Adult Contemporary")
                
                @schemas.classproperty
                def EASY_LISTENING(cls):
                    return cls("Easy Listening")
                
                @schemas.classproperty
                def COMEDY_MUSIC(cls):
                    return cls("Comedy Music")
                
                @schemas.classproperty
                def NEW_AGE(cls):
                    return cls("New Age")
                
                @schemas.classproperty
                def CHANSON(cls):
                    return cls("Chanson")
                
                @schemas.classproperty
                def SINGER_SONGWRITER(cls):
                    return cls("Singer/Songwriter")
                
                @schemas.classproperty
                def SCHLAGER(cls):
                    return cls("Schlager")
                
                @schemas.classproperty
                def VOLKSMUSIK(cls):
                    return cls("Volksmusik")
                
                @schemas.classproperty
                def ROCKNROLL(cls):
                    return cls("Rock'n'Roll")
                
                @schemas.classproperty
                def ROCKABILLY(cls):
                    return cls("Rockabilly")
                
                @schemas.classproperty
                def PSYCHOBILLY(cls):
                    return cls("Psychobilly")
                
                @schemas.classproperty
                def SURF(cls):
                    return cls("Surf")
                
                @schemas.classproperty
                def DOO_WOP(cls):
                    return cls("Doo Wop")
                
                @schemas.classproperty
                def MAINSTREAM_ROCK(cls):
                    return cls("Mainstream Rock")
                
                @schemas.classproperty
                def MERSEY_BEAT(cls):
                    return cls("Mersey Beat")
                
                @schemas.classproperty
                def GLAMROCK(cls):
                    return cls("Glamrock")
                
                @schemas.classproperty
                def LATIN_ROCK(cls):
                    return cls("Latin Rock")
                
                @schemas.classproperty
                def MELODIC_ROCK(cls):
                    return cls("Melodic Rock")
                
                @schemas.classproperty
                def PROGRESSIVE_ROCK(cls):
                    return cls("Progressive Rock")
                
                @schemas.classproperty
                def PSYCHEDELIC_ROCK(cls):
                    return cls("Psychedelic Rock")
                
                @schemas.classproperty
                def HARD_ROCK(cls):
                    return cls("Hard Rock")
                
                @schemas.classproperty
                def KRAUTROCK(cls):
                    return cls("Krautrock")
                
                @schemas.classproperty
                def POWER_METAL(cls):
                    return cls("Power Metal")
                
                @schemas.classproperty
                def NU_METAL(cls):
                    return cls("Nu Metal")
                
                @schemas.classproperty
                def GRIND_CORE(cls):
                    return cls("Grind Core")
                
                @schemas.classproperty
                def GOTHIC_METAL(cls):
                    return cls("Gothic Metal")
                
                @schemas.classproperty
                def DEATH_METAL(cls):
                    return cls("Death Metal")
                
                @schemas.classproperty
                def MELODIC_DEATH_METAL(cls):
                    return cls("Melodic Death Metal")
                
                @schemas.classproperty
                def THRASH_METAL(cls):
                    return cls("Thrash Metal")
                
                @schemas.classproperty
                def BLACK_METAL(cls):
                    return cls("Black Metal")
                
                @schemas.classproperty
                def GLAM_METAL(cls):
                    return cls("Glam Metal")
                
                @schemas.classproperty
                def SLEAZE_METAL(cls):
                    return cls("Sleaze Metal")
                
                @schemas.classproperty
                def METALCORE(cls):
                    return cls("Metalcore")
                
                @schemas.classproperty
                def PROGRESSIVE_METAL(cls):
                    return cls("Progressive Metal")
                
                @schemas.classproperty
                def SCREAMO(cls):
                    return cls("Screamo")
                
                @schemas.classproperty
                def SYMPHONIC_METAL(cls):
                    return cls("Symphonic Metal")
                
                @schemas.classproperty
                def SWING(cls):
                    return cls("Swing")
                
                @schemas.classproperty
                def RAGTIME(cls):
                    return cls("Ragtime")
                
                @schemas.classproperty
                def DIXIELAND(cls):
                    return cls("Dixieland")
                
                @schemas.classproperty
                def BOOGIE_WOOGIE(cls):
                    return cls("Boogie Woogie")
                
                @schemas.classproperty
                def BEBOP(cls):
                    return cls("Bebop")
                
                @schemas.classproperty
                def COOL_JAZZ(cls):
                    return cls("Cool Jazz")
                
                @schemas.classproperty
                def FREE_JAZZ(cls):
                    return cls("Free Jazz")
                
                @schemas.classproperty
                def FUSION(cls):
                    return cls("Fusion")
                
                @schemas.classproperty
                def SMOOTH_JAZZ(cls):
                    return cls("Smooth Jazz")
                
                @schemas.classproperty
                def ACID_JAZZ(cls):
                    return cls("Acid Jazz")
                
                @schemas.classproperty
                def BOSSA_NOVA(cls):
                    return cls("Bossa Nova")
                
                @schemas.classproperty
                def LATIN_JAZZ(cls):
                    return cls("Latin Jazz")
                
                @schemas.classproperty
                def NUJAZZ(cls):
                    return cls("Nu-Jazz")
                
                @schemas.classproperty
                def TANGO(cls):
                    return cls("Tango")
                
                @schemas.classproperty
                def SAMBA(cls):
                    return cls("Samba")
                
                @schemas.classproperty
                def SALSA(cls):
                    return cls("Salsa")
                
                @schemas.classproperty
                def AX(cls):
                    return cls("Axé")
                
                @schemas.classproperty
                def SERTANEJO(cls):
                    return cls("Sertanejo")
                
                @schemas.classproperty
                def FORR(cls):
                    return cls("Forró")
                
                @schemas.classproperty
                def CHORO(cls):
                    return cls("Choro")
                
                @schemas.classproperty
                def FADO(cls):
                    return cls("Fado")
                
                @schemas.classproperty
                def FLAMENCO(cls):
                    return cls("Flamenco")
                
                @schemas.classproperty
                def BLASMUSIK(cls):
                    return cls("Blasmusik")
                
                @schemas.classproperty
                def AMERICAN_FOLK(cls):
                    return cls("American Folk")
                
                @schemas.classproperty
                def IRISH_FOLK(cls):
                    return cls("Irish Folk")
                
                @schemas.classproperty
                def AMERICANA(cls):
                    return cls("Americana")
                
                @schemas.classproperty
                def BLUEGRASS(cls):
                    return cls("Bluegrass")
                
                @schemas.classproperty
                def RED_DIRT(cls):
                    return cls("Red Dirt")
                
                @schemas.classproperty
                def OUTLAW_COUNTRY(cls):
                    return cls("Outlaw Country")
                
                @schemas.classproperty
                def NASHVILLE(cls):
                    return cls("Nashville")
                
                @schemas.classproperty
                def HONKYTONK(cls):
                    return cls("Honkytonk")
                
                @schemas.classproperty
                def PRODUCTION_MUSIC(cls):
                    return cls("Production Music")
                
                @schemas.classproperty
                def SOUNDTRACK(cls):
                    return cls("Soundtrack")
                
                @schemas.classproperty
                def MUSICAL(cls):
                    return cls("Musical")
                
                @schemas.classproperty
                def MEDIEVAL(cls):
                    return cls("Medieval")
                
                @schemas.classproperty
                def RENAISSANCE(cls):
                    return cls("Renaissance")
                
                @schemas.classproperty
                def BAROQUE(cls):
                    return cls("Baroque")
                
                @schemas.classproperty
                def CLASSICAL_PERIOD(cls):
                    return cls("Classical Period")
                
                @schemas.classproperty
                def ROMANTICISM(cls):
                    return cls("Romanticism")
                
                @schemas.classproperty
                def NEUE_MUSIK(cls):
                    return cls("Neue Musik")
                
                @schemas.classproperty
                def MINIMAL_MUSIC(cls):
                    return cls("Minimal Music")
                
                @schemas.classproperty
                def NEOKLASSIK(cls):
                    return cls("Neoklassik")
                
                @schemas.classproperty
                def POSTMODERNE_MUSIK(cls):
                    return cls("Postmoderne Musik")
                
                @schemas.classproperty
                def PUNK(cls):
                    return cls("Punk")
                
                @schemas.classproperty
                def NOISE_ROCK(cls):
                    return cls("Noise Rock")
                
                @schemas.classproperty
                def GARAGE(cls):
                    return cls("Garage")
                
                @schemas.classproperty
                def GRUNGE(cls):
                    return cls("Grunge")
                
                @schemas.classproperty
                def INDUSTRIAL(cls):
                    return cls("Industrial")
                
                @schemas.classproperty
                def NEW_WAVE(cls):
                    return cls("New Wave")
                
                @schemas.classproperty
                def POST_PUNK(cls):
                    return cls("Post Punk")
                
                @schemas.classproperty
                def GOTHIC_ROCK(cls):
                    return cls("Gothic Rock")
                
                @schemas.classproperty
                def STONER_ROCK(cls):
                    return cls("Stoner Rock")
                
                @schemas.classproperty
                def POP_PUNK(cls):
                    return cls("Pop Punk")
                
                @schemas.classproperty
                def POST_HARDCORE(cls):
                    return cls("Post Hardcore")
                
                @schemas.classproperty
                def POST_ROCK(cls):
                    return cls("Post Rock")
                
                @schemas.classproperty
                def POST_METAL(cls):
                    return cls("Post Metal")
                
                @schemas.classproperty
                def POSTGRUNGE(cls):
                    return cls("Post-Grunge")
                
                @schemas.classproperty
                def BRITPOP(cls):
                    return cls("Britpop")
                
                @schemas.classproperty
                def SKA_PUNK(cls):
                    return cls("Ska Punk")
                
                @schemas.classproperty
                def MATH_ROCK(cls):
                    return cls("Math Rock")
                
                @schemas.classproperty
                def DREAMPOP(cls):
                    return cls("Dreampop")
                
                @schemas.classproperty
                def SHOEGAZE(cls):
                    return cls("Shoegaze")
                
                @schemas.classproperty
                def CONTEMPORARY_RB(cls):
                    return cls("Contemporary R&B")
                
                @schemas.classproperty
                def RHYTHM_AND_BLUES(cls):
                    return cls("Rhythm And Blues")
                
                @schemas.classproperty
                def DISCO(cls):
                    return cls("Disco")
                
                @schemas.classproperty
                def CHICAGO_SOUL(cls):
                    return cls("Chicago Soul")
                
                @schemas.classproperty
                def DETROIT_SOUL(cls):
                    return cls("Detroit Soul")
                
                @schemas.classproperty
                def URBAN(cls):
                    return cls("Urban")
                
                @schemas.classproperty
                def NU_RB(cls):
                    return cls("Nu R&B")
                
                @schemas.classproperty
                def NEO_SOUL(cls):
                    return cls("Neo Soul")
                
                @schemas.classproperty
                def EARLY_FUNK(cls):
                    return cls("Early Funk")
                
                @schemas.classproperty
                def FUNK_ROCK(cls):
                    return cls("Funk Rock")
                
                @schemas.classproperty
                def FOLK_BLUES(cls):
                    return cls("Folk Blues")
                
                @schemas.classproperty
                def CLASSICS_BLUES(cls):
                    return cls("Classics Blues")
                
                @schemas.classproperty
                def BLUES_ROCK(cls):
                    return cls("Blues Rock")
                
                @schemas.classproperty
                def TRAP_MUSIC(cls):
                    return cls("Trap Music")
                
                @schemas.classproperty
                def ELECTROHOP(cls):
                    return cls("Electro-hop")
                
                @schemas.classproperty
                def HARDCORE_RAP(cls):
                    return cls("Hardcore Rap")
                
                @schemas.classproperty
                def MIAMI_BASS__BOUNCE(cls):
                    return cls("Miami Bass & Bounce")
                
                @schemas.classproperty
                def DIRTY_SOUTH_RAP(cls):
                    return cls("Dirty South Rap")
                
                @schemas.classproperty
                def TURNTABLISM(cls):
                    return cls("Turntablism")
                
                @schemas.classproperty
                def WEST_COAST_GANGSTA_RAP(cls):
                    return cls("West Coast Gangsta Rap")
                
                @schemas.classproperty
                def EAST_COAST_GANGSTA_RAP(cls):
                    return cls("East Coast Gangsta Rap")
                
                @schemas.classproperty
                def ROOTSREGGAE(cls):
                    return cls("Roots-Reggae")
                
                @schemas.classproperty
                def DUB(cls):
                    return cls("Dub")
                
                @schemas.classproperty
                def RAGGAMUFFIN(cls):
                    return cls("Raggamuffin")
                
                @schemas.classproperty
                def SKA(cls):
                    return cls("Ska")
                
                @schemas.classproperty
                def DANCEHALL(cls):
                    return cls("Dancehall")
                
                @schemas.classproperty
                def CHICAGO_HOUSE(cls):
                    return cls("Chicago House")
                
                @schemas.classproperty
                def AMBIENT_HOUSE(cls):
                    return cls("Ambient House")
                
                @schemas.classproperty
                def DEEP_HOUSE(cls):
                    return cls("Deep House")
                
                @schemas.classproperty
                def TECH_HOUSE(cls):
                    return cls("Tech House")
                
                @schemas.classproperty
                def ACID_HOUSE(cls):
                    return cls("Acid House")
                
                @schemas.classproperty
                def DUTCH_HOUSE(cls):
                    return cls("Dutch House")
                
                @schemas.classproperty
                def PROGRESSIVE_HOUSE(cls):
                    return cls("Progressive House")
                
                @schemas.classproperty
                def FUNKY_HOUSE(cls):
                    return cls("Funky House")
                
                @schemas.classproperty
                def NU_DISCO(cls):
                    return cls("Nu Disco")
                
                @schemas.classproperty
                def MINIMAL_TECHNO(cls):
                    return cls("Minimal Techno")
                
                @schemas.classproperty
                def HARDCORE_TECHNO(cls):
                    return cls("Hardcore Techno")
                
                @schemas.classproperty
                def IDM(cls):
                    return cls("IDM")
                
                @schemas.classproperty
                def TRANCE(cls):
                    return cls("Trance")
                
                @schemas.classproperty
                def PSYTRANCE(cls):
                    return cls("Psytrance")
                
                @schemas.classproperty
                def PROGRESSIVE_TRANCE(cls):
                    return cls("Progressive Trance")
                
                @schemas.classproperty
                def GRIME(cls):
                    return cls("Grime")
                
                @schemas.classproperty
                def BIG_BEAT(cls):
                    return cls("Big Beat")
                
                @schemas.classproperty
                def DUB_STEP(cls):
                    return cls("Dub Step")
                
                @schemas.classproperty
                def LIQUID_FUNK(cls):
                    return cls("Liquid Funk")
                
                @schemas.classproperty
                def HARD_STEP(cls):
                    return cls("Hard Step")
                
                @schemas.classproperty
                def JUMP_UP(cls):
                    return cls("Jump Up")
                
                @schemas.classproperty
                def OLD_SCHOOL_JUNGLE(cls):
                    return cls("Old School Jungle")
                
                @schemas.classproperty
                def TRIP_HOP(cls):
                    return cls("Trip Hop")
                
                @schemas.classproperty
                def GOSPEL(cls):
                    return cls("Gospel")
                
                @schemas.classproperty
                def DANCEPOP(cls):
                    return cls("Dancepop")
                
                @schemas.classproperty
                def INDIETRONICA(cls):
                    return cls("Indietronica")
                
                @schemas.classproperty
                def NU_RAVE(cls):
                    return cls("Nu Rave")
                
                @schemas.classproperty
                def EMOROCK(cls):
                    return cls("Emo-Rock")
                
                @schemas.classproperty
                def POSTPUNK_REVIVAL(cls):
                    return cls("Post-Punk Revival")
                
                @schemas.classproperty
                def NU_PROG(cls):
                    return cls("Nu Prog")
                
                @schemas.classproperty
                def INDIE_FOLK(cls):
                    return cls("Indie Folk")
                
                @schemas.classproperty
                def AUDIOBOOK(cls):
                    return cls("Audiobook")
                
                @schemas.classproperty
                def AUDIOPLAY(cls):
                    return cls("Audioplay")
                
                @schemas.classproperty
                def RELAXATION(cls):
                    return cls("Relaxation")
                
                @schemas.classproperty
                def AMBIENT_HOUSE___CHILLOUT(cls):
                    return cls("Ambient House / Chill-Out")
                
                @schemas.classproperty
                def CHEMICAL_BREAKS__BIG_BEAT(cls):
                    return cls("Chemical Breaks & Big Beat")
                
                @schemas.classproperty
                def CHICAGO_HOUSE__GARAGE_HOUSE(cls):
                    return cls("Chicago House & Garage House")
                
                @schemas.classproperty
                def CHICAGO_SOUL__DETROIT_SOUL(cls):
                    return cls("Chicago Soul & Detroit Soul")
                
                @schemas.classproperty
                def COMEDY(cls):
                    return cls("Comedy")
                
                @schemas.classproperty
                def DARK_WAVE(cls):
                    return cls("Dark Wave")
                
                @schemas.classproperty
                def DREAMPOP__SHOEGAZE(cls):
                    return cls("Dreampop & Shoegaze")
                
                @schemas.classproperty
                def ELECTRO_HOUSE__DUTCH_HOUSE(cls):
                    return cls("Electro House & Dutch House")
                
                @schemas.classproperty
                def FRENCH_HOUSE__FUNKY_HOUSE(cls):
                    return cls("French House & Funky House")
                
                @schemas.classproperty
                def GOLDEN_AGE_RAD__HARDCORE_RAP(cls):
                    return cls("Golden Age Rad & Hardcore Rap")
                
                @schemas.classproperty
                def HARD_STEP__TECH_STEP(cls):
                    return cls("Hard Step & Tech Step")
                
                @schemas.classproperty
                def INDIETRONICA__CHILLWAVE(cls):
                    return cls("Indietronica & Chillwave")
                
                @schemas.classproperty
                def NU_DISCO__FUNKTRONICA(cls):
                    return cls("Nu Disco & Funktronica")
                
                @schemas.classproperty
                def DOOM_METAL(cls):
                    return cls("Doom Metal")
                
                @schemas.classproperty
                def MATHCORE(cls):
                    return cls("Mathcore")
                
                @schemas.classproperty
                def PSY_TRANCE(cls):
                    return cls("Psy Trance")
                
                @schemas.classproperty
                def ROOTS_ROCK(cls):
                    return cls("Roots Rock")
            tertiaryLevel2GenreAffinity = schemas.Float32Schema
            
            
            class curateability(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "curateable": "CURATEABLE",
                        "uncurateable": "UNCURATEABLE",
                    }
                
                @schemas.classproperty
                def CURATEABLE(cls):
                    return cls("curateable")
                
                @schemas.classproperty
                def UNCURATEABLE(cls):
                    return cls("uncurateable")
            curateabilityAffinity = schemas.Float32Schema
            
            
            class useCase(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "background": "BACKGROUND",
                        "sport": "SPORT",
                        "focus": "FOCUS",
                        "christmas": "CHRISTMAS",
                        "film": "FILM",
                        "summer": "SUMMER",
                        "adverts": "ADVERTS",
                        "party": "PARTY",
                        "relax": "RELAX",
                    }
                
                @schemas.classproperty
                def BACKGROUND(cls):
                    return cls("background")
                
                @schemas.classproperty
                def SPORT(cls):
                    return cls("sport")
                
                @schemas.classproperty
                def FOCUS(cls):
                    return cls("focus")
                
                @schemas.classproperty
                def CHRISTMAS(cls):
                    return cls("christmas")
                
                @schemas.classproperty
                def FILM(cls):
                    return cls("film")
                
                @schemas.classproperty
                def SUMMER(cls):
                    return cls("summer")
                
                @schemas.classproperty
                def ADVERTS(cls):
                    return cls("adverts")
                
                @schemas.classproperty
                def PARTY(cls):
                    return cls("party")
                
                @schemas.classproperty
                def RELAX(cls):
                    return cls("relax")
            useCaseAffinity = schemas.Float32Schema
            
            
            class socialMedia(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "Spotify": "SPOTIFY",
                        "TikTok": "TIK_TOK",
                        "Unfitting": "UNFITTING",
                        "YouTube": "YOU_TUBE",
                    }
                
                @schemas.classproperty
                def SPOTIFY(cls):
                    return cls("Spotify")
                
                @schemas.classproperty
                def TIK_TOK(cls):
                    return cls("TikTok")
                
                @schemas.classproperty
                def UNFITTING(cls):
                    return cls("Unfitting")
                
                @schemas.classproperty
                def YOU_TUBE(cls):
                    return cls("YouTube")
            socialMediaAffinity = schemas.Float32Schema
            
            
            class industrySuitability(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "Automobiles and Parts": "AUTOMOBILES_AND_PARTS",
                        "Consumer Products and Services": "CONSUMER_PRODUCTS_AND_SERVICES",
                        "Financial Services": "FINANCIAL_SERVICES",
                        "Food, Beverage and Tobacco": "FOOD_BEVERAGE_AND_TOBACCO",
                        "Health Care": "HEALTH_CARE",
                        "Insurance": "INSURANCE",
                        "Media": "MEDIA",
                        "Politics, Government and Organizations": "POLITICS_GOVERNMENT_AND_ORGANIZATIONS",
                        "Real Estate": "REAL_ESTATE",
                        "Retail": "RETAIL",
                        "Technology": "TECHNOLOGY",
                        "Telecommunications": "TELECOMMUNICATIONS",
                        "Travel and Leisure": "TRAVEL_AND_LEISURE",
                    }
                
                @schemas.classproperty
                def AUTOMOBILES_AND_PARTS(cls):
                    return cls("Automobiles and Parts")
                
                @schemas.classproperty
                def CONSUMER_PRODUCTS_AND_SERVICES(cls):
                    return cls("Consumer Products and Services")
                
                @schemas.classproperty
                def FINANCIAL_SERVICES(cls):
                    return cls("Financial Services")
                
                @schemas.classproperty
                def FOOD_BEVERAGE_AND_TOBACCO(cls):
                    return cls("Food, Beverage and Tobacco")
                
                @schemas.classproperty
                def HEALTH_CARE(cls):
                    return cls("Health Care")
                
                @schemas.classproperty
                def INSURANCE(cls):
                    return cls("Insurance")
                
                @schemas.classproperty
                def MEDIA(cls):
                    return cls("Media")
                
                @schemas.classproperty
                def POLITICS_GOVERNMENT_AND_ORGANIZATIONS(cls):
                    return cls("Politics, Government and Organizations")
                
                @schemas.classproperty
                def REAL_ESTATE(cls):
                    return cls("Real Estate")
                
                @schemas.classproperty
                def RETAIL(cls):
                    return cls("Retail")
                
                @schemas.classproperty
                def TECHNOLOGY(cls):
                    return cls("Technology")
                
                @schemas.classproperty
                def TELECOMMUNICATIONS(cls):
                    return cls("Telecommunications")
                
                @schemas.classproperty
                def TRAVEL_AND_LEISURE(cls):
                    return cls("Travel and Leisure")
            industrySuitabilityAffinity = schemas.Float32Schema
            
            
            class tags(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['SaveRecordingTagDTO']:
                        return SaveRecordingTagDTO
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['SaveRecordingTagDTO'], typing.List['SaveRecordingTagDTO']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'tags':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'SaveRecordingTagDTO':
                    return super().__getitem__(i)
            
            
            class genres(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['SaveRecordingGenreDTO']:
                        return SaveRecordingGenreDTO
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['SaveRecordingGenreDTO'], typing.List['SaveRecordingGenreDTO']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'genres':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'SaveRecordingGenreDTO':
                    return super().__getitem__(i)
            
            
            class parties(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['SaveRecordingPartyDTO']:
                        return SaveRecordingPartyDTO
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['SaveRecordingPartyDTO'], typing.List['SaveRecordingPartyDTO']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'parties':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'SaveRecordingPartyDTO':
                    return super().__getitem__(i)
            iswc = schemas.StrSchema
            proprietaryIdGema = schemas.StrSchema
            title = schemas.StrSchema
            versionTitle = schemas.StrSchema
            __annotations__ = {
                "isrc": isrc,
                "createdByVersion": createdByVersion,
                "name": name,
                "folder": folder,
                "primaryMoodClusterAffinity": primaryMoodClusterAffinity,
                "primaryMoodCluster": primaryMoodCluster,
                "secondaryMoodClusterAffinity": secondaryMoodClusterAffinity,
                "secondaryMoodCluster": secondaryMoodCluster,
                "tertiaryMoodClusterAffinity": tertiaryMoodClusterAffinity,
                "tertiaryMoodCluster": tertiaryMoodCluster,
                "valenceAffinity": valenceAffinity,
                "arousalAffinity": arousalAffinity,
                "pleasantnessAffinity": pleasantnessAffinity,
                "engagementAffinity": engagementAffinity,
                "valence": valence,
                "arousal": arousal,
                "pleasantness": pleasantness,
                "engagement": engagement,
                "vocals": vocals,
                "vocalsAffinity": vocalsAffinity,
                "dominantInstrument": dominantInstrument,
                "dominantInstrumentAffinity": dominantInstrumentAffinity,
                "secondaryInstrumentAffinity": secondaryInstrumentAffinity,
                "secondaryInstrument": secondaryInstrument,
                "tertiaryInstrumentAffinity": tertiaryInstrumentAffinity,
                "tertiaryInstrument": tertiaryInstrument,
                "energy": energy,
                "energyAffinity": energyAffinity,
                "soundGeneration": soundGeneration,
                "soundGenerationAffinity": soundGenerationAffinity,
                "tempo": tempo,
                "tempoAffinity": tempoAffinity,
                "scale": scale,
                "scaleAffinity": scaleAffinity,
                "rhythm": rhythm,
                "rhythmAffinity": rhythmAffinity,
                "primarySoundCharacter": primarySoundCharacter,
                "primarySoundCharacterAffinity": primarySoundCharacterAffinity,
                "timbreAffinity": timbreAffinity,
                "roughnessAffinity": roughnessAffinity,
                "tonalityAffinity": tonalityAffinity,
                "harmonyAffinity": harmonyAffinity,
                "textureAffinity": textureAffinity,
                "groovynessAffinity": groovynessAffinity,
                "spaceAffinity": spaceAffinity,
                "timbre": timbre,
                "roughness": roughness,
                "tonality": tonality,
                "harmony": harmony,
                "texture": texture,
                "groovyness": groovyness,
                "space": space,
                "bpm": bpm,
                "key": key,
                "keyAffinity": keyAffinity,
                "productionRating": productionRating,
                "productionRatingAffinity": productionRatingAffinity,
                "performanceRating": performanceRating,
                "performanceRatingAffinity": performanceRatingAffinity,
                "songRating": songRating,
                "songRatingAffinity": songRatingAffinity,
                "audienceGender": audienceGender,
                "audienceGenderAffinity": audienceGenderAffinity,
                "audienceRegion": audienceRegion,
                "audienceRegionAffinity": audienceRegionAffinity,
                "secondaryAudienceRegionAffinity": secondaryAudienceRegionAffinity,
                "secondaryAudienceRegion": secondaryAudienceRegion,
                "tertiaryAudienceRegionAffinity": tertiaryAudienceRegionAffinity,
                "tertiaryAudienceRegion": tertiaryAudienceRegion,
                "audienceAge": audienceAge,
                "audienceAgeAffinity": audienceAgeAffinity,
                "secondaryAudienceAge": secondaryAudienceAge,
                "secondaryAudienceAgeAffinity": secondaryAudienceAgeAffinity,
                "tertiaryAudienceAge": tertiaryAudienceAge,
                "tertiaryAudienceAgeAffinity": tertiaryAudienceAgeAffinity,
                "originDecade": originDecade,
                "originDecadeAffinity": originDecadeAffinity,
                "languageOfPerformance": languageOfPerformance,
                "languageOfPerformanceAffinity": languageOfPerformanceAffinity,
                "originRegion": originRegion,
                "originRegionAffinity": originRegionAffinity,
                "taggrams": taggrams,
                "embeddings": embeddings,
                "level1Genre": level1Genre,
                "level1GenreAffinity": level1GenreAffinity,
                "secondaryLevel1Genre": secondaryLevel1Genre,
                "secondaryLevel1GenreAffinity": secondaryLevel1GenreAffinity,
                "tertiaryLevel1Genre": tertiaryLevel1Genre,
                "tertiaryLevel1GenreAffinity": tertiaryLevel1GenreAffinity,
                "level2Genre": level2Genre,
                "level2GenreAffinity": level2GenreAffinity,
                "secondaryLevel2Genre": secondaryLevel2Genre,
                "secondaryLevel2GenreAffinity": secondaryLevel2GenreAffinity,
                "tertiaryLevel2Genre": tertiaryLevel2Genre,
                "tertiaryLevel2GenreAffinity": tertiaryLevel2GenreAffinity,
                "curateability": curateability,
                "curateabilityAffinity": curateabilityAffinity,
                "useCase": useCase,
                "useCaseAffinity": useCaseAffinity,
                "socialMedia": socialMedia,
                "socialMediaAffinity": socialMediaAffinity,
                "industrySuitability": industrySuitability,
                "industrySuitabilityAffinity": industrySuitabilityAffinity,
                "tags": tags,
                "genres": genres,
                "parties": parties,
                "iswc": iswc,
                "proprietaryIdGema": proprietaryIdGema,
                "title": title,
                "versionTitle": versionTitle,
            }
    
    createdByVersion: MetaOapg.properties.createdByVersion
    isrc: MetaOapg.properties.isrc
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["isrc"]) -> MetaOapg.properties.isrc: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["createdByVersion"]) -> MetaOapg.properties.createdByVersion: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["folder"]) -> MetaOapg.properties.folder: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["primaryMoodClusterAffinity"]) -> MetaOapg.properties.primaryMoodClusterAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["primaryMoodCluster"]) -> MetaOapg.properties.primaryMoodCluster: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["secondaryMoodClusterAffinity"]) -> MetaOapg.properties.secondaryMoodClusterAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["secondaryMoodCluster"]) -> MetaOapg.properties.secondaryMoodCluster: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tertiaryMoodClusterAffinity"]) -> MetaOapg.properties.tertiaryMoodClusterAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tertiaryMoodCluster"]) -> MetaOapg.properties.tertiaryMoodCluster: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["valenceAffinity"]) -> MetaOapg.properties.valenceAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["arousalAffinity"]) -> MetaOapg.properties.arousalAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["pleasantnessAffinity"]) -> MetaOapg.properties.pleasantnessAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["engagementAffinity"]) -> MetaOapg.properties.engagementAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["valence"]) -> MetaOapg.properties.valence: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["arousal"]) -> MetaOapg.properties.arousal: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["pleasantness"]) -> MetaOapg.properties.pleasantness: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["engagement"]) -> MetaOapg.properties.engagement: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["vocals"]) -> MetaOapg.properties.vocals: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["vocalsAffinity"]) -> MetaOapg.properties.vocalsAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["dominantInstrument"]) -> MetaOapg.properties.dominantInstrument: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["dominantInstrumentAffinity"]) -> MetaOapg.properties.dominantInstrumentAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["secondaryInstrumentAffinity"]) -> MetaOapg.properties.secondaryInstrumentAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["secondaryInstrument"]) -> MetaOapg.properties.secondaryInstrument: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tertiaryInstrumentAffinity"]) -> MetaOapg.properties.tertiaryInstrumentAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tertiaryInstrument"]) -> MetaOapg.properties.tertiaryInstrument: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["energy"]) -> MetaOapg.properties.energy: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["energyAffinity"]) -> MetaOapg.properties.energyAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["soundGeneration"]) -> MetaOapg.properties.soundGeneration: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["soundGenerationAffinity"]) -> MetaOapg.properties.soundGenerationAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tempo"]) -> MetaOapg.properties.tempo: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tempoAffinity"]) -> MetaOapg.properties.tempoAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["scale"]) -> MetaOapg.properties.scale: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["scaleAffinity"]) -> MetaOapg.properties.scaleAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["rhythm"]) -> MetaOapg.properties.rhythm: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["rhythmAffinity"]) -> MetaOapg.properties.rhythmAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["primarySoundCharacter"]) -> MetaOapg.properties.primarySoundCharacter: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["primarySoundCharacterAffinity"]) -> MetaOapg.properties.primarySoundCharacterAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["timbreAffinity"]) -> MetaOapg.properties.timbreAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["roughnessAffinity"]) -> MetaOapg.properties.roughnessAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tonalityAffinity"]) -> MetaOapg.properties.tonalityAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["harmonyAffinity"]) -> MetaOapg.properties.harmonyAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["textureAffinity"]) -> MetaOapg.properties.textureAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["groovynessAffinity"]) -> MetaOapg.properties.groovynessAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["spaceAffinity"]) -> MetaOapg.properties.spaceAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["timbre"]) -> MetaOapg.properties.timbre: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["roughness"]) -> MetaOapg.properties.roughness: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tonality"]) -> MetaOapg.properties.tonality: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["harmony"]) -> MetaOapg.properties.harmony: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["texture"]) -> MetaOapg.properties.texture: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["groovyness"]) -> MetaOapg.properties.groovyness: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["space"]) -> MetaOapg.properties.space: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["bpm"]) -> MetaOapg.properties.bpm: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["key"]) -> MetaOapg.properties.key: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["keyAffinity"]) -> MetaOapg.properties.keyAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["productionRating"]) -> MetaOapg.properties.productionRating: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["productionRatingAffinity"]) -> MetaOapg.properties.productionRatingAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["performanceRating"]) -> MetaOapg.properties.performanceRating: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["performanceRatingAffinity"]) -> MetaOapg.properties.performanceRatingAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["songRating"]) -> MetaOapg.properties.songRating: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["songRatingAffinity"]) -> MetaOapg.properties.songRatingAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["audienceGender"]) -> MetaOapg.properties.audienceGender: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["audienceGenderAffinity"]) -> MetaOapg.properties.audienceGenderAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["audienceRegion"]) -> MetaOapg.properties.audienceRegion: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["audienceRegionAffinity"]) -> MetaOapg.properties.audienceRegionAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["secondaryAudienceRegionAffinity"]) -> MetaOapg.properties.secondaryAudienceRegionAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["secondaryAudienceRegion"]) -> MetaOapg.properties.secondaryAudienceRegion: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tertiaryAudienceRegionAffinity"]) -> MetaOapg.properties.tertiaryAudienceRegionAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tertiaryAudienceRegion"]) -> MetaOapg.properties.tertiaryAudienceRegion: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["audienceAge"]) -> MetaOapg.properties.audienceAge: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["audienceAgeAffinity"]) -> MetaOapg.properties.audienceAgeAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["secondaryAudienceAge"]) -> MetaOapg.properties.secondaryAudienceAge: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["secondaryAudienceAgeAffinity"]) -> MetaOapg.properties.secondaryAudienceAgeAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tertiaryAudienceAge"]) -> MetaOapg.properties.tertiaryAudienceAge: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tertiaryAudienceAgeAffinity"]) -> MetaOapg.properties.tertiaryAudienceAgeAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["originDecade"]) -> MetaOapg.properties.originDecade: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["originDecadeAffinity"]) -> MetaOapg.properties.originDecadeAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["languageOfPerformance"]) -> MetaOapg.properties.languageOfPerformance: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["languageOfPerformanceAffinity"]) -> MetaOapg.properties.languageOfPerformanceAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["originRegion"]) -> MetaOapg.properties.originRegion: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["originRegionAffinity"]) -> MetaOapg.properties.originRegionAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["taggrams"]) -> 'SaveTaggramsDTO': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["embeddings"]) -> MetaOapg.properties.embeddings: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["level1Genre"]) -> MetaOapg.properties.level1Genre: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["level1GenreAffinity"]) -> MetaOapg.properties.level1GenreAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["secondaryLevel1Genre"]) -> MetaOapg.properties.secondaryLevel1Genre: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["secondaryLevel1GenreAffinity"]) -> MetaOapg.properties.secondaryLevel1GenreAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tertiaryLevel1Genre"]) -> MetaOapg.properties.tertiaryLevel1Genre: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tertiaryLevel1GenreAffinity"]) -> MetaOapg.properties.tertiaryLevel1GenreAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["level2Genre"]) -> MetaOapg.properties.level2Genre: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["level2GenreAffinity"]) -> MetaOapg.properties.level2GenreAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["secondaryLevel2Genre"]) -> MetaOapg.properties.secondaryLevel2Genre: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["secondaryLevel2GenreAffinity"]) -> MetaOapg.properties.secondaryLevel2GenreAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tertiaryLevel2Genre"]) -> MetaOapg.properties.tertiaryLevel2Genre: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tertiaryLevel2GenreAffinity"]) -> MetaOapg.properties.tertiaryLevel2GenreAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["curateability"]) -> MetaOapg.properties.curateability: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["curateabilityAffinity"]) -> MetaOapg.properties.curateabilityAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["useCase"]) -> MetaOapg.properties.useCase: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["useCaseAffinity"]) -> MetaOapg.properties.useCaseAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["socialMedia"]) -> MetaOapg.properties.socialMedia: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["socialMediaAffinity"]) -> MetaOapg.properties.socialMediaAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["industrySuitability"]) -> MetaOapg.properties.industrySuitability: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["industrySuitabilityAffinity"]) -> MetaOapg.properties.industrySuitabilityAffinity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tags"]) -> MetaOapg.properties.tags: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["genres"]) -> MetaOapg.properties.genres: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["parties"]) -> MetaOapg.properties.parties: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["iswc"]) -> MetaOapg.properties.iswc: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["proprietaryIdGema"]) -> MetaOapg.properties.proprietaryIdGema: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["title"]) -> MetaOapg.properties.title: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["versionTitle"]) -> MetaOapg.properties.versionTitle: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["isrc", "createdByVersion", "name", "folder", "primaryMoodClusterAffinity", "primaryMoodCluster", "secondaryMoodClusterAffinity", "secondaryMoodCluster", "tertiaryMoodClusterAffinity", "tertiaryMoodCluster", "valenceAffinity", "arousalAffinity", "pleasantnessAffinity", "engagementAffinity", "valence", "arousal", "pleasantness", "engagement", "vocals", "vocalsAffinity", "dominantInstrument", "dominantInstrumentAffinity", "secondaryInstrumentAffinity", "secondaryInstrument", "tertiaryInstrumentAffinity", "tertiaryInstrument", "energy", "energyAffinity", "soundGeneration", "soundGenerationAffinity", "tempo", "tempoAffinity", "scale", "scaleAffinity", "rhythm", "rhythmAffinity", "primarySoundCharacter", "primarySoundCharacterAffinity", "timbreAffinity", "roughnessAffinity", "tonalityAffinity", "harmonyAffinity", "textureAffinity", "groovynessAffinity", "spaceAffinity", "timbre", "roughness", "tonality", "harmony", "texture", "groovyness", "space", "bpm", "key", "keyAffinity", "productionRating", "productionRatingAffinity", "performanceRating", "performanceRatingAffinity", "songRating", "songRatingAffinity", "audienceGender", "audienceGenderAffinity", "audienceRegion", "audienceRegionAffinity", "secondaryAudienceRegionAffinity", "secondaryAudienceRegion", "tertiaryAudienceRegionAffinity", "tertiaryAudienceRegion", "audienceAge", "audienceAgeAffinity", "secondaryAudienceAge", "secondaryAudienceAgeAffinity", "tertiaryAudienceAge", "tertiaryAudienceAgeAffinity", "originDecade", "originDecadeAffinity", "languageOfPerformance", "languageOfPerformanceAffinity", "originRegion", "originRegionAffinity", "taggrams", "embeddings", "level1Genre", "level1GenreAffinity", "secondaryLevel1Genre", "secondaryLevel1GenreAffinity", "tertiaryLevel1Genre", "tertiaryLevel1GenreAffinity", "level2Genre", "level2GenreAffinity", "secondaryLevel2Genre", "secondaryLevel2GenreAffinity", "tertiaryLevel2Genre", "tertiaryLevel2GenreAffinity", "curateability", "curateabilityAffinity", "useCase", "useCaseAffinity", "socialMedia", "socialMediaAffinity", "industrySuitability", "industrySuitabilityAffinity", "tags", "genres", "parties", "iswc", "proprietaryIdGema", "title", "versionTitle", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["isrc"]) -> MetaOapg.properties.isrc: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["createdByVersion"]) -> MetaOapg.properties.createdByVersion: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["name"]) -> typing.Union[MetaOapg.properties.name, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["folder"]) -> typing.Union[MetaOapg.properties.folder, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["primaryMoodClusterAffinity"]) -> typing.Union[MetaOapg.properties.primaryMoodClusterAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["primaryMoodCluster"]) -> typing.Union[MetaOapg.properties.primaryMoodCluster, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["secondaryMoodClusterAffinity"]) -> typing.Union[MetaOapg.properties.secondaryMoodClusterAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["secondaryMoodCluster"]) -> typing.Union[MetaOapg.properties.secondaryMoodCluster, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tertiaryMoodClusterAffinity"]) -> typing.Union[MetaOapg.properties.tertiaryMoodClusterAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tertiaryMoodCluster"]) -> typing.Union[MetaOapg.properties.tertiaryMoodCluster, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["valenceAffinity"]) -> typing.Union[MetaOapg.properties.valenceAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["arousalAffinity"]) -> typing.Union[MetaOapg.properties.arousalAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["pleasantnessAffinity"]) -> typing.Union[MetaOapg.properties.pleasantnessAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["engagementAffinity"]) -> typing.Union[MetaOapg.properties.engagementAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["valence"]) -> typing.Union[MetaOapg.properties.valence, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["arousal"]) -> typing.Union[MetaOapg.properties.arousal, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["pleasantness"]) -> typing.Union[MetaOapg.properties.pleasantness, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["engagement"]) -> typing.Union[MetaOapg.properties.engagement, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["vocals"]) -> typing.Union[MetaOapg.properties.vocals, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["vocalsAffinity"]) -> typing.Union[MetaOapg.properties.vocalsAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["dominantInstrument"]) -> typing.Union[MetaOapg.properties.dominantInstrument, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["dominantInstrumentAffinity"]) -> typing.Union[MetaOapg.properties.dominantInstrumentAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["secondaryInstrumentAffinity"]) -> typing.Union[MetaOapg.properties.secondaryInstrumentAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["secondaryInstrument"]) -> typing.Union[MetaOapg.properties.secondaryInstrument, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tertiaryInstrumentAffinity"]) -> typing.Union[MetaOapg.properties.tertiaryInstrumentAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tertiaryInstrument"]) -> typing.Union[MetaOapg.properties.tertiaryInstrument, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["energy"]) -> typing.Union[MetaOapg.properties.energy, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["energyAffinity"]) -> typing.Union[MetaOapg.properties.energyAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["soundGeneration"]) -> typing.Union[MetaOapg.properties.soundGeneration, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["soundGenerationAffinity"]) -> typing.Union[MetaOapg.properties.soundGenerationAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tempo"]) -> typing.Union[MetaOapg.properties.tempo, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tempoAffinity"]) -> typing.Union[MetaOapg.properties.tempoAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["scale"]) -> typing.Union[MetaOapg.properties.scale, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["scaleAffinity"]) -> typing.Union[MetaOapg.properties.scaleAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["rhythm"]) -> typing.Union[MetaOapg.properties.rhythm, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["rhythmAffinity"]) -> typing.Union[MetaOapg.properties.rhythmAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["primarySoundCharacter"]) -> typing.Union[MetaOapg.properties.primarySoundCharacter, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["primarySoundCharacterAffinity"]) -> typing.Union[MetaOapg.properties.primarySoundCharacterAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["timbreAffinity"]) -> typing.Union[MetaOapg.properties.timbreAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["roughnessAffinity"]) -> typing.Union[MetaOapg.properties.roughnessAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tonalityAffinity"]) -> typing.Union[MetaOapg.properties.tonalityAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["harmonyAffinity"]) -> typing.Union[MetaOapg.properties.harmonyAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["textureAffinity"]) -> typing.Union[MetaOapg.properties.textureAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["groovynessAffinity"]) -> typing.Union[MetaOapg.properties.groovynessAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["spaceAffinity"]) -> typing.Union[MetaOapg.properties.spaceAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["timbre"]) -> typing.Union[MetaOapg.properties.timbre, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["roughness"]) -> typing.Union[MetaOapg.properties.roughness, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tonality"]) -> typing.Union[MetaOapg.properties.tonality, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["harmony"]) -> typing.Union[MetaOapg.properties.harmony, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["texture"]) -> typing.Union[MetaOapg.properties.texture, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["groovyness"]) -> typing.Union[MetaOapg.properties.groovyness, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["space"]) -> typing.Union[MetaOapg.properties.space, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["bpm"]) -> typing.Union[MetaOapg.properties.bpm, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["key"]) -> typing.Union[MetaOapg.properties.key, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["keyAffinity"]) -> typing.Union[MetaOapg.properties.keyAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["productionRating"]) -> typing.Union[MetaOapg.properties.productionRating, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["productionRatingAffinity"]) -> typing.Union[MetaOapg.properties.productionRatingAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["performanceRating"]) -> typing.Union[MetaOapg.properties.performanceRating, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["performanceRatingAffinity"]) -> typing.Union[MetaOapg.properties.performanceRatingAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["songRating"]) -> typing.Union[MetaOapg.properties.songRating, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["songRatingAffinity"]) -> typing.Union[MetaOapg.properties.songRatingAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["audienceGender"]) -> typing.Union[MetaOapg.properties.audienceGender, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["audienceGenderAffinity"]) -> typing.Union[MetaOapg.properties.audienceGenderAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["audienceRegion"]) -> typing.Union[MetaOapg.properties.audienceRegion, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["audienceRegionAffinity"]) -> typing.Union[MetaOapg.properties.audienceRegionAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["secondaryAudienceRegionAffinity"]) -> typing.Union[MetaOapg.properties.secondaryAudienceRegionAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["secondaryAudienceRegion"]) -> typing.Union[MetaOapg.properties.secondaryAudienceRegion, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tertiaryAudienceRegionAffinity"]) -> typing.Union[MetaOapg.properties.tertiaryAudienceRegionAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tertiaryAudienceRegion"]) -> typing.Union[MetaOapg.properties.tertiaryAudienceRegion, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["audienceAge"]) -> typing.Union[MetaOapg.properties.audienceAge, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["audienceAgeAffinity"]) -> typing.Union[MetaOapg.properties.audienceAgeAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["secondaryAudienceAge"]) -> typing.Union[MetaOapg.properties.secondaryAudienceAge, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["secondaryAudienceAgeAffinity"]) -> typing.Union[MetaOapg.properties.secondaryAudienceAgeAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tertiaryAudienceAge"]) -> typing.Union[MetaOapg.properties.tertiaryAudienceAge, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tertiaryAudienceAgeAffinity"]) -> typing.Union[MetaOapg.properties.tertiaryAudienceAgeAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["originDecade"]) -> typing.Union[MetaOapg.properties.originDecade, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["originDecadeAffinity"]) -> typing.Union[MetaOapg.properties.originDecadeAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["languageOfPerformance"]) -> typing.Union[MetaOapg.properties.languageOfPerformance, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["languageOfPerformanceAffinity"]) -> typing.Union[MetaOapg.properties.languageOfPerformanceAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["originRegion"]) -> typing.Union[MetaOapg.properties.originRegion, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["originRegionAffinity"]) -> typing.Union[MetaOapg.properties.originRegionAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["taggrams"]) -> typing.Union['SaveTaggramsDTO', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["embeddings"]) -> typing.Union[MetaOapg.properties.embeddings, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["level1Genre"]) -> typing.Union[MetaOapg.properties.level1Genre, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["level1GenreAffinity"]) -> typing.Union[MetaOapg.properties.level1GenreAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["secondaryLevel1Genre"]) -> typing.Union[MetaOapg.properties.secondaryLevel1Genre, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["secondaryLevel1GenreAffinity"]) -> typing.Union[MetaOapg.properties.secondaryLevel1GenreAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tertiaryLevel1Genre"]) -> typing.Union[MetaOapg.properties.tertiaryLevel1Genre, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tertiaryLevel1GenreAffinity"]) -> typing.Union[MetaOapg.properties.tertiaryLevel1GenreAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["level2Genre"]) -> typing.Union[MetaOapg.properties.level2Genre, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["level2GenreAffinity"]) -> typing.Union[MetaOapg.properties.level2GenreAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["secondaryLevel2Genre"]) -> typing.Union[MetaOapg.properties.secondaryLevel2Genre, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["secondaryLevel2GenreAffinity"]) -> typing.Union[MetaOapg.properties.secondaryLevel2GenreAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tertiaryLevel2Genre"]) -> typing.Union[MetaOapg.properties.tertiaryLevel2Genre, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tertiaryLevel2GenreAffinity"]) -> typing.Union[MetaOapg.properties.tertiaryLevel2GenreAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["curateability"]) -> typing.Union[MetaOapg.properties.curateability, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["curateabilityAffinity"]) -> typing.Union[MetaOapg.properties.curateabilityAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["useCase"]) -> typing.Union[MetaOapg.properties.useCase, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["useCaseAffinity"]) -> typing.Union[MetaOapg.properties.useCaseAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["socialMedia"]) -> typing.Union[MetaOapg.properties.socialMedia, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["socialMediaAffinity"]) -> typing.Union[MetaOapg.properties.socialMediaAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["industrySuitability"]) -> typing.Union[MetaOapg.properties.industrySuitability, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["industrySuitabilityAffinity"]) -> typing.Union[MetaOapg.properties.industrySuitabilityAffinity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tags"]) -> typing.Union[MetaOapg.properties.tags, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["genres"]) -> typing.Union[MetaOapg.properties.genres, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["parties"]) -> typing.Union[MetaOapg.properties.parties, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["iswc"]) -> typing.Union[MetaOapg.properties.iswc, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["proprietaryIdGema"]) -> typing.Union[MetaOapg.properties.proprietaryIdGema, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["title"]) -> typing.Union[MetaOapg.properties.title, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["versionTitle"]) -> typing.Union[MetaOapg.properties.versionTitle, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["isrc", "createdByVersion", "name", "folder", "primaryMoodClusterAffinity", "primaryMoodCluster", "secondaryMoodClusterAffinity", "secondaryMoodCluster", "tertiaryMoodClusterAffinity", "tertiaryMoodCluster", "valenceAffinity", "arousalAffinity", "pleasantnessAffinity", "engagementAffinity", "valence", "arousal", "pleasantness", "engagement", "vocals", "vocalsAffinity", "dominantInstrument", "dominantInstrumentAffinity", "secondaryInstrumentAffinity", "secondaryInstrument", "tertiaryInstrumentAffinity", "tertiaryInstrument", "energy", "energyAffinity", "soundGeneration", "soundGenerationAffinity", "tempo", "tempoAffinity", "scale", "scaleAffinity", "rhythm", "rhythmAffinity", "primarySoundCharacter", "primarySoundCharacterAffinity", "timbreAffinity", "roughnessAffinity", "tonalityAffinity", "harmonyAffinity", "textureAffinity", "groovynessAffinity", "spaceAffinity", "timbre", "roughness", "tonality", "harmony", "texture", "groovyness", "space", "bpm", "key", "keyAffinity", "productionRating", "productionRatingAffinity", "performanceRating", "performanceRatingAffinity", "songRating", "songRatingAffinity", "audienceGender", "audienceGenderAffinity", "audienceRegion", "audienceRegionAffinity", "secondaryAudienceRegionAffinity", "secondaryAudienceRegion", "tertiaryAudienceRegionAffinity", "tertiaryAudienceRegion", "audienceAge", "audienceAgeAffinity", "secondaryAudienceAge", "secondaryAudienceAgeAffinity", "tertiaryAudienceAge", "tertiaryAudienceAgeAffinity", "originDecade", "originDecadeAffinity", "languageOfPerformance", "languageOfPerformanceAffinity", "originRegion", "originRegionAffinity", "taggrams", "embeddings", "level1Genre", "level1GenreAffinity", "secondaryLevel1Genre", "secondaryLevel1GenreAffinity", "tertiaryLevel1Genre", "tertiaryLevel1GenreAffinity", "level2Genre", "level2GenreAffinity", "secondaryLevel2Genre", "secondaryLevel2GenreAffinity", "tertiaryLevel2Genre", "tertiaryLevel2GenreAffinity", "curateability", "curateabilityAffinity", "useCase", "useCaseAffinity", "socialMedia", "socialMediaAffinity", "industrySuitability", "industrySuitabilityAffinity", "tags", "genres", "parties", "iswc", "proprietaryIdGema", "title", "versionTitle", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        createdByVersion: typing.Union[MetaOapg.properties.createdByVersion, str, ],
        isrc: typing.Union[MetaOapg.properties.isrc, str, ],
        name: typing.Union[MetaOapg.properties.name, str, schemas.Unset] = schemas.unset,
        folder: typing.Union[MetaOapg.properties.folder, str, schemas.Unset] = schemas.unset,
        primaryMoodClusterAffinity: typing.Union[MetaOapg.properties.primaryMoodClusterAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        primaryMoodCluster: typing.Union[MetaOapg.properties.primaryMoodCluster, str, schemas.Unset] = schemas.unset,
        secondaryMoodClusterAffinity: typing.Union[MetaOapg.properties.secondaryMoodClusterAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        secondaryMoodCluster: typing.Union[MetaOapg.properties.secondaryMoodCluster, str, schemas.Unset] = schemas.unset,
        tertiaryMoodClusterAffinity: typing.Union[MetaOapg.properties.tertiaryMoodClusterAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        tertiaryMoodCluster: typing.Union[MetaOapg.properties.tertiaryMoodCluster, str, schemas.Unset] = schemas.unset,
        valenceAffinity: typing.Union[MetaOapg.properties.valenceAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        arousalAffinity: typing.Union[MetaOapg.properties.arousalAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        pleasantnessAffinity: typing.Union[MetaOapg.properties.pleasantnessAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        engagementAffinity: typing.Union[MetaOapg.properties.engagementAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        valence: typing.Union[MetaOapg.properties.valence, str, schemas.Unset] = schemas.unset,
        arousal: typing.Union[MetaOapg.properties.arousal, str, schemas.Unset] = schemas.unset,
        pleasantness: typing.Union[MetaOapg.properties.pleasantness, str, schemas.Unset] = schemas.unset,
        engagement: typing.Union[MetaOapg.properties.engagement, str, schemas.Unset] = schemas.unset,
        vocals: typing.Union[MetaOapg.properties.vocals, str, schemas.Unset] = schemas.unset,
        vocalsAffinity: typing.Union[MetaOapg.properties.vocalsAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        dominantInstrument: typing.Union[MetaOapg.properties.dominantInstrument, str, schemas.Unset] = schemas.unset,
        dominantInstrumentAffinity: typing.Union[MetaOapg.properties.dominantInstrumentAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        secondaryInstrumentAffinity: typing.Union[MetaOapg.properties.secondaryInstrumentAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        secondaryInstrument: typing.Union[MetaOapg.properties.secondaryInstrument, str, schemas.Unset] = schemas.unset,
        tertiaryInstrumentAffinity: typing.Union[MetaOapg.properties.tertiaryInstrumentAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        tertiaryInstrument: typing.Union[MetaOapg.properties.tertiaryInstrument, str, schemas.Unset] = schemas.unset,
        energy: typing.Union[MetaOapg.properties.energy, str, schemas.Unset] = schemas.unset,
        energyAffinity: typing.Union[MetaOapg.properties.energyAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        soundGeneration: typing.Union[MetaOapg.properties.soundGeneration, str, schemas.Unset] = schemas.unset,
        soundGenerationAffinity: typing.Union[MetaOapg.properties.soundGenerationAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        tempo: typing.Union[MetaOapg.properties.tempo, str, schemas.Unset] = schemas.unset,
        tempoAffinity: typing.Union[MetaOapg.properties.tempoAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        scale: typing.Union[MetaOapg.properties.scale, str, schemas.Unset] = schemas.unset,
        scaleAffinity: typing.Union[MetaOapg.properties.scaleAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        rhythm: typing.Union[MetaOapg.properties.rhythm, str, schemas.Unset] = schemas.unset,
        rhythmAffinity: typing.Union[MetaOapg.properties.rhythmAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        primarySoundCharacter: typing.Union[MetaOapg.properties.primarySoundCharacter, str, schemas.Unset] = schemas.unset,
        primarySoundCharacterAffinity: typing.Union[MetaOapg.properties.primarySoundCharacterAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        timbreAffinity: typing.Union[MetaOapg.properties.timbreAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        roughnessAffinity: typing.Union[MetaOapg.properties.roughnessAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        tonalityAffinity: typing.Union[MetaOapg.properties.tonalityAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        harmonyAffinity: typing.Union[MetaOapg.properties.harmonyAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        textureAffinity: typing.Union[MetaOapg.properties.textureAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        groovynessAffinity: typing.Union[MetaOapg.properties.groovynessAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        spaceAffinity: typing.Union[MetaOapg.properties.spaceAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        timbre: typing.Union[MetaOapg.properties.timbre, str, schemas.Unset] = schemas.unset,
        roughness: typing.Union[MetaOapg.properties.roughness, str, schemas.Unset] = schemas.unset,
        tonality: typing.Union[MetaOapg.properties.tonality, str, schemas.Unset] = schemas.unset,
        harmony: typing.Union[MetaOapg.properties.harmony, str, schemas.Unset] = schemas.unset,
        texture: typing.Union[MetaOapg.properties.texture, str, schemas.Unset] = schemas.unset,
        groovyness: typing.Union[MetaOapg.properties.groovyness, str, schemas.Unset] = schemas.unset,
        space: typing.Union[MetaOapg.properties.space, str, schemas.Unset] = schemas.unset,
        bpm: typing.Union[MetaOapg.properties.bpm, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        key: typing.Union[MetaOapg.properties.key, str, schemas.Unset] = schemas.unset,
        keyAffinity: typing.Union[MetaOapg.properties.keyAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        productionRating: typing.Union[MetaOapg.properties.productionRating, str, schemas.Unset] = schemas.unset,
        productionRatingAffinity: typing.Union[MetaOapg.properties.productionRatingAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        performanceRating: typing.Union[MetaOapg.properties.performanceRating, str, schemas.Unset] = schemas.unset,
        performanceRatingAffinity: typing.Union[MetaOapg.properties.performanceRatingAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        songRating: typing.Union[MetaOapg.properties.songRating, str, schemas.Unset] = schemas.unset,
        songRatingAffinity: typing.Union[MetaOapg.properties.songRatingAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        audienceGender: typing.Union[MetaOapg.properties.audienceGender, str, schemas.Unset] = schemas.unset,
        audienceGenderAffinity: typing.Union[MetaOapg.properties.audienceGenderAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        audienceRegion: typing.Union[MetaOapg.properties.audienceRegion, str, schemas.Unset] = schemas.unset,
        audienceRegionAffinity: typing.Union[MetaOapg.properties.audienceRegionAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        secondaryAudienceRegionAffinity: typing.Union[MetaOapg.properties.secondaryAudienceRegionAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        secondaryAudienceRegion: typing.Union[MetaOapg.properties.secondaryAudienceRegion, str, schemas.Unset] = schemas.unset,
        tertiaryAudienceRegionAffinity: typing.Union[MetaOapg.properties.tertiaryAudienceRegionAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        tertiaryAudienceRegion: typing.Union[MetaOapg.properties.tertiaryAudienceRegion, str, schemas.Unset] = schemas.unset,
        audienceAge: typing.Union[MetaOapg.properties.audienceAge, str, schemas.Unset] = schemas.unset,
        audienceAgeAffinity: typing.Union[MetaOapg.properties.audienceAgeAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        secondaryAudienceAge: typing.Union[MetaOapg.properties.secondaryAudienceAge, str, schemas.Unset] = schemas.unset,
        secondaryAudienceAgeAffinity: typing.Union[MetaOapg.properties.secondaryAudienceAgeAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        tertiaryAudienceAge: typing.Union[MetaOapg.properties.tertiaryAudienceAge, str, schemas.Unset] = schemas.unset,
        tertiaryAudienceAgeAffinity: typing.Union[MetaOapg.properties.tertiaryAudienceAgeAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        originDecade: typing.Union[MetaOapg.properties.originDecade, str, schemas.Unset] = schemas.unset,
        originDecadeAffinity: typing.Union[MetaOapg.properties.originDecadeAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        languageOfPerformance: typing.Union[MetaOapg.properties.languageOfPerformance, str, schemas.Unset] = schemas.unset,
        languageOfPerformanceAffinity: typing.Union[MetaOapg.properties.languageOfPerformanceAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        originRegion: typing.Union[MetaOapg.properties.originRegion, str, schemas.Unset] = schemas.unset,
        originRegionAffinity: typing.Union[MetaOapg.properties.originRegionAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        taggrams: typing.Union['SaveTaggramsDTO', schemas.Unset] = schemas.unset,
        embeddings: typing.Union[MetaOapg.properties.embeddings, list, tuple, schemas.Unset] = schemas.unset,
        level1Genre: typing.Union[MetaOapg.properties.level1Genre, str, schemas.Unset] = schemas.unset,
        level1GenreAffinity: typing.Union[MetaOapg.properties.level1GenreAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        secondaryLevel1Genre: typing.Union[MetaOapg.properties.secondaryLevel1Genre, str, schemas.Unset] = schemas.unset,
        secondaryLevel1GenreAffinity: typing.Union[MetaOapg.properties.secondaryLevel1GenreAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        tertiaryLevel1Genre: typing.Union[MetaOapg.properties.tertiaryLevel1Genre, str, schemas.Unset] = schemas.unset,
        tertiaryLevel1GenreAffinity: typing.Union[MetaOapg.properties.tertiaryLevel1GenreAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        level2Genre: typing.Union[MetaOapg.properties.level2Genre, str, schemas.Unset] = schemas.unset,
        level2GenreAffinity: typing.Union[MetaOapg.properties.level2GenreAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        secondaryLevel2Genre: typing.Union[MetaOapg.properties.secondaryLevel2Genre, str, schemas.Unset] = schemas.unset,
        secondaryLevel2GenreAffinity: typing.Union[MetaOapg.properties.secondaryLevel2GenreAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        tertiaryLevel2Genre: typing.Union[MetaOapg.properties.tertiaryLevel2Genre, str, schemas.Unset] = schemas.unset,
        tertiaryLevel2GenreAffinity: typing.Union[MetaOapg.properties.tertiaryLevel2GenreAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        curateability: typing.Union[MetaOapg.properties.curateability, str, schemas.Unset] = schemas.unset,
        curateabilityAffinity: typing.Union[MetaOapg.properties.curateabilityAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        useCase: typing.Union[MetaOapg.properties.useCase, str, schemas.Unset] = schemas.unset,
        useCaseAffinity: typing.Union[MetaOapg.properties.useCaseAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        socialMedia: typing.Union[MetaOapg.properties.socialMedia, str, schemas.Unset] = schemas.unset,
        socialMediaAffinity: typing.Union[MetaOapg.properties.socialMediaAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        industrySuitability: typing.Union[MetaOapg.properties.industrySuitability, str, schemas.Unset] = schemas.unset,
        industrySuitabilityAffinity: typing.Union[MetaOapg.properties.industrySuitabilityAffinity, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        tags: typing.Union[MetaOapg.properties.tags, list, tuple, schemas.Unset] = schemas.unset,
        genres: typing.Union[MetaOapg.properties.genres, list, tuple, schemas.Unset] = schemas.unset,
        parties: typing.Union[MetaOapg.properties.parties, list, tuple, schemas.Unset] = schemas.unset,
        iswc: typing.Union[MetaOapg.properties.iswc, str, schemas.Unset] = schemas.unset,
        proprietaryIdGema: typing.Union[MetaOapg.properties.proprietaryIdGema, str, schemas.Unset] = schemas.unset,
        title: typing.Union[MetaOapg.properties.title, str, schemas.Unset] = schemas.unset,
        versionTitle: typing.Union[MetaOapg.properties.versionTitle, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'SaveFileRecordingDTO':
        return super().__new__(
            cls,
            *_args,
            createdByVersion=createdByVersion,
            isrc=isrc,
            name=name,
            folder=folder,
            primaryMoodClusterAffinity=primaryMoodClusterAffinity,
            primaryMoodCluster=primaryMoodCluster,
            secondaryMoodClusterAffinity=secondaryMoodClusterAffinity,
            secondaryMoodCluster=secondaryMoodCluster,
            tertiaryMoodClusterAffinity=tertiaryMoodClusterAffinity,
            tertiaryMoodCluster=tertiaryMoodCluster,
            valenceAffinity=valenceAffinity,
            arousalAffinity=arousalAffinity,
            pleasantnessAffinity=pleasantnessAffinity,
            engagementAffinity=engagementAffinity,
            valence=valence,
            arousal=arousal,
            pleasantness=pleasantness,
            engagement=engagement,
            vocals=vocals,
            vocalsAffinity=vocalsAffinity,
            dominantInstrument=dominantInstrument,
            dominantInstrumentAffinity=dominantInstrumentAffinity,
            secondaryInstrumentAffinity=secondaryInstrumentAffinity,
            secondaryInstrument=secondaryInstrument,
            tertiaryInstrumentAffinity=tertiaryInstrumentAffinity,
            tertiaryInstrument=tertiaryInstrument,
            energy=energy,
            energyAffinity=energyAffinity,
            soundGeneration=soundGeneration,
            soundGenerationAffinity=soundGenerationAffinity,
            tempo=tempo,
            tempoAffinity=tempoAffinity,
            scale=scale,
            scaleAffinity=scaleAffinity,
            rhythm=rhythm,
            rhythmAffinity=rhythmAffinity,
            primarySoundCharacter=primarySoundCharacter,
            primarySoundCharacterAffinity=primarySoundCharacterAffinity,
            timbreAffinity=timbreAffinity,
            roughnessAffinity=roughnessAffinity,
            tonalityAffinity=tonalityAffinity,
            harmonyAffinity=harmonyAffinity,
            textureAffinity=textureAffinity,
            groovynessAffinity=groovynessAffinity,
            spaceAffinity=spaceAffinity,
            timbre=timbre,
            roughness=roughness,
            tonality=tonality,
            harmony=harmony,
            texture=texture,
            groovyness=groovyness,
            space=space,
            bpm=bpm,
            key=key,
            keyAffinity=keyAffinity,
            productionRating=productionRating,
            productionRatingAffinity=productionRatingAffinity,
            performanceRating=performanceRating,
            performanceRatingAffinity=performanceRatingAffinity,
            songRating=songRating,
            songRatingAffinity=songRatingAffinity,
            audienceGender=audienceGender,
            audienceGenderAffinity=audienceGenderAffinity,
            audienceRegion=audienceRegion,
            audienceRegionAffinity=audienceRegionAffinity,
            secondaryAudienceRegionAffinity=secondaryAudienceRegionAffinity,
            secondaryAudienceRegion=secondaryAudienceRegion,
            tertiaryAudienceRegionAffinity=tertiaryAudienceRegionAffinity,
            tertiaryAudienceRegion=tertiaryAudienceRegion,
            audienceAge=audienceAge,
            audienceAgeAffinity=audienceAgeAffinity,
            secondaryAudienceAge=secondaryAudienceAge,
            secondaryAudienceAgeAffinity=secondaryAudienceAgeAffinity,
            tertiaryAudienceAge=tertiaryAudienceAge,
            tertiaryAudienceAgeAffinity=tertiaryAudienceAgeAffinity,
            originDecade=originDecade,
            originDecadeAffinity=originDecadeAffinity,
            languageOfPerformance=languageOfPerformance,
            languageOfPerformanceAffinity=languageOfPerformanceAffinity,
            originRegion=originRegion,
            originRegionAffinity=originRegionAffinity,
            taggrams=taggrams,
            embeddings=embeddings,
            level1Genre=level1Genre,
            level1GenreAffinity=level1GenreAffinity,
            secondaryLevel1Genre=secondaryLevel1Genre,
            secondaryLevel1GenreAffinity=secondaryLevel1GenreAffinity,
            tertiaryLevel1Genre=tertiaryLevel1Genre,
            tertiaryLevel1GenreAffinity=tertiaryLevel1GenreAffinity,
            level2Genre=level2Genre,
            level2GenreAffinity=level2GenreAffinity,
            secondaryLevel2Genre=secondaryLevel2Genre,
            secondaryLevel2GenreAffinity=secondaryLevel2GenreAffinity,
            tertiaryLevel2Genre=tertiaryLevel2Genre,
            tertiaryLevel2GenreAffinity=tertiaryLevel2GenreAffinity,
            curateability=curateability,
            curateabilityAffinity=curateabilityAffinity,
            useCase=useCase,
            useCaseAffinity=useCaseAffinity,
            socialMedia=socialMedia,
            socialMediaAffinity=socialMediaAffinity,
            industrySuitability=industrySuitability,
            industrySuitabilityAffinity=industrySuitabilityAffinity,
            tags=tags,
            genres=genres,
            parties=parties,
            iswc=iswc,
            proprietaryIdGema=proprietaryIdGema,
            title=title,
            versionTitle=versionTitle,
            _configuration=_configuration,
            **kwargs,
        )

from songtradr_api_client_python.model.save_recording_genre_dto import SaveRecordingGenreDTO
from songtradr_api_client_python.model.save_recording_party_dto import SaveRecordingPartyDTO
from songtradr_api_client_python.model.save_recording_tag_dto import SaveRecordingTagDTO
from songtradr_api_client_python.model.save_taggrams_dto import SaveTaggramsDTO
